--	http://www.easybytez.com/*

function GDL(origUrl)
	logpref = script.name..'_GDL_0007'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, wait, dirUrl

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)
	if page:find('>File Not Found<',1, true) then return usd.setretresult('%notfound%') end
	if page:find('>File not available<',1, true) then return usd.setretresult('%deleted%') end
	err = page:match('class="err">(.-)<')
	if err then
		usd.savetolog('Error: '..err)
		return usd.setretresult('%notfound%')
	end

	if origUrl:find('/users/',1, true) then
		local folder = page:match('class="file_block">(.-)</TD></Table>')
		if folder then
			if not folder:find('class="link"><a href=',1, true) then
				return usd.setretresult('%Folder has no files?')
			end

			folder:gsub('class="link"><a href="([^"]+)"[^>]+>(.-)</a></div>(.-)<br>'
			, function(url, name, size)
				usd.savetolog(url)
				usd.savetolog('  '..name:gsub("&#(%d+);", function(n) return string.char(n) end)..size)
				usd.addquery(url)
			end)
			return usd.setretresult('%done%')
		else
			return usd.setretresult('%Folder has no files?')
		end
	end

	form = page:match('<Form.-</Form>')
	if not form then return usd.setretresult('%No free download?') end
	form = Form.parse(form)
	usd.waittime(math.random(1,7))
	page = form:submit('method_free')
	debugSaveInc(logpref..'.html', page)

	form = page:match('<Form name="F1".-</Form>')
	if not form then return usd.setretresult('%F1 not found') end
	err = form:match('class="err">(.-)<')
	if err then
		local hh = err:match(' (%d+) hour') or 0
		local mm = err:match(' (%d+) minute') or 0
		local ss = err:match(' (%d+) second') or 0
		wait = (hh*60 + mm)*60 + ss
		if wait > 0 then
			usd.setretresult('%Server report: You need wait '..wait..' seconds')
			return
		end
		usd.savetolog('Error: '..err)
		return usd.setretresult('%notfound%')
	end

	wait = form:match('id="countdown_str">Wait <span id=[^>]+>(%d+)</span> second') or 0
	newName = form:match('Filename:</b></td><td nowrap>(.-)</td>')
	newName = utf8ToAnsi(newName)

	local pic = form:match('<img src="([^"]+)" class="pic"')
	if pic then
		return usd.setretresult(pic,0,1)
	else
		form = Form.parse(form)
		dirUrl = addNewName(origUrl, newName)
		usd.setretresult(dirUrl, wait+math.random(1,7),0, form:getinputs())
		return
	end
end

function OS(origUrl, dirUrl, fullName)
	return usd.setretresult(fileRename(fullName, newName))
end

regDirSuccess( 'easybytez.com/', GDL, OS )

