
function GDL(origUrl)
	logpref = script.name..'_GDL_0007'
	usd.setstatus(logpref:gsub('_GDL_',' '))
	local page, form, err, wait, cap4a, dirUrl

	if origUrl:find('allbox4.com/',1, true) then
		origUrl = origUrl:gsub('/embed%-','/'):gsub('%.html$','')
	end

	local page, badpage = tryDl(origUrl, nil,nil, '</[Hh][Tt][Mm][Ll]>')
	debugSaveInc(logpref..'.html', page or badpage)
	if badpage then return usd.setretresult('%Bad page') end
	if page:find('>File Not Found<',1, true)
		or page:find('>File not found<',1, true)
		or page:find('Error: File Not Found',1, true) then
		return usd.setretresult('%notfound%')
	end
	if page:find('Error: The file was removed',1, true) then
		return usd.setretresult('%deleted%')
	end
	err = page:match('class="err">(.-)<')
		or page:match('class="dl_err">%s*(.-)<')
	if err then return usd.setretresult('%'..err) end

	if not origUrl:find('rarefile.net/',1, true) then
		form = page:match('<[Ff]orm method="POST" action=\'\' id="F1" name="F1">.-</[Ff]orm>') -- allbox4.com
			or page:match('<[Ff]orm method="POST" action=\'\'>.-</[Ff]orm>')
			or page:match('<[Ff]orm method="POST">.-</[Ff]orm>')
		if not form then return usd.setretresult('%No free download?') end
		form = Form.parse(form)
		if not form.submits.method_free then form.submits.method_free = 'Free Download' end
		usd.waittime(math.random(1,7))
		page = form:submit('method_free')
		debugSaveInc(logpref..'.html', page)

		err = page:match('class="err">(.-)<')
			or page:match('class="dl_err">%s*(.-)<')
		if err then return usd.setretresult('%'..err) end
	end

	form = page:match('<[Ff]orm name="F1".-</[Ff]orm>')
	if not form then return usd.setretresult('%F1 not found') end
	cap4a = form:match('<img src="(http://[^"]+/captchas/[^"]+)"')
	wait = form:match('id="countdown_str".-<span.->%s*(%d+)%s*</span>') or 60
	form = Form.parse(form)
	if form.action == '' then form.action = origUrl end
	form.inputs.code = queryCaptcha(cap4a)
	usd.relocationmode(0)
	usd.waittime(wait)
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	err = page:match('class="err">(.-)<')
		or page:match('class="dl_err">%s*(.-)<')
	if err then return usd.setretresult('%'..err) end

	dirUrl = page:match('href="(http://[^/]+:%d+/d/[^"]+)"')
		or page:match('href="(http://[^/]+/files/[^"]+)"')
		or usd.getheaders():match('Location: ([%S]+/dl%.cgi/[^%c]+)',2)
		or usd.getheaders():match('Location: ([%S]+:%d+/d/[^%c]+)',2)
		or page:match("location='(http://[^/]+:%d+/d/[^']+)'")
	if not dirUrl then return usd.setretresult('%dirUrl not found') end
	usd.setretresult(dirUrl, math.random(1,7),1)
	return
end

regDirSuccess( 'filecloud.ws/', GDL, OS )
regDirSuccess( '100shared.com/', GDL, OS )
regDirSuccess( 'upgrand.com/', GDL, OS )
regDirSuccess( 'imzupload.com/', GDL, OS )
regDirSuccess( 'maskshare.com/', GDL, OS )
regDirSuccess( 'fireloading.com/', GDL, OS )
regDirSuccess( 'filevice.com/', GDL, OS )
--	regDirSuccess( 'secureupload.eu/', GDL, OS ) --  
--	regDirSuccess( 'mlfat4arab.com/', GDL, OS ) --  
regDirSuccess( 'rarefile.net/', GDL, OS )
regDirSuccess( 'fileband.com/', GDL, OS )
regDirSuccess( 'filewinds.com/', GDL, OS )
regDirSuccess( 'filedownloads.org/', GDL, OS )
regDirSuccess( 'netuploaded.com/', GDL, OS )
regDirSuccess( 'terabit.to/', GDL, OS )

regDirSuccess( {'.allbox4.com/', '//allbox4.com/'}, GDL, OS )

regDirSuccess( {'.ifile.ws/', '//ifile.ws/'}, GDL, OS )

