--GDL

local conf = tableCombine({ key='thrjozkaskhjastaurrtygitylpt' }, Settings[script.name] or {})
conf.mirrors = conf.mirrors or {'//bandcamp.com/', '.bandcamp.com/'}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, form

	local function api(mod,query)
		query.key = query.key or conf.key
		local page = usd.get('http://api.bandcamp.com/api/'..mod..'?'..tableConcat(query,'=','&',escapeUC))
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))
        return data
	end

	script.tmp={}
	script.cache = script.cache or {album={},band={},url={}}

	function cache(tbl, key, mod, query)
		if not key then return end
		local tmp = script.cache[tbl][key]
		if tmp then
			debugLog(('cached %s[%s]'):format(tbl, key))
		else
			tmp = api(mod, query)
			script.cache[tbl][key] = tmp
		end
		return tmp
	end

	local uri = URI.parse(origUrl)
	if uri.path:lower():find('^/embeddedplayer[/.]') then
		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page)
		origUrl = page:match('<input id="shareurl" type="text" value="([^"]+)"')
		usd.modquery(origUrl)
	end

	local urlInfo = api('url/1/info',{url=origUrl})

	if urlInfo.error_message then return usd.setretresult('%'..urlInfo.error_message) end

	if urlInfo.track_id then
		local data = api('track/3/info',urlInfo)
		local album = cache('album', data.album_id, 'album/2/info',{album_id=data.album_id})
		local band = cache('band', data.band_id, 'band/3/info', urlInfo)
		usd.relocationmode(0)
		debugSaveInc(logpref..'.html', usd.get(data.streaming_url))
		dirUrl = usd.getheaders():match('%sLocation: (http[^\r\n]+)')
		local tmp = album and {band.name, os.date('%Y', album.release_date or 0), album.title, pad(data.number, 2), data.title}
			or {band.name, data.title}
		script.tmp.newName = filterName(utf8ToAnsi(table.concat(tmp	,'-')), true)
		usd.setretresult(dirUrl,1,1)
	    return
	end

	if urlInfo.album_id then
		local album = cache('album', urlInfo.album_id, 'album/2/info', urlInfo)
		local uri = URI.parse(album.url)
		for k,v in ipairs(album.tracks) do
			usd.addquery((uri(v.url)():gsub('%?.*$','')))
		end
		usd.setretresult('%done%')
		return
	end

	if urlInfo.band_id then
		local data = api('band/3/discography',urlInfo)
		for k, v in ipairs(data.discography) do
			usd.addquery((v.url:gsub('%?.*$','')))
		end
		usd.setretresult('%done%')
		return
	end


	usd.setretresult('%plugindefect')
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.mp3'))
end

regDirSuccess( conf.mirrors, GDL, OS)
