
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri, data
	script.tmp={}

	local conf = Settings[script.name] or {
		  interactive = false
		, qualityList = {720, 480, 360, 290, 240}
	}
	debugLog('conf='..serialize(conf,nil,nil,true))

	local fmt = tonumber(origUrl:match('#fmt=(%w+)'))
	origUrl = origUrl:match('^([^#]+)')
	if origUrl:find('http://carambatv.ru/oembed/') then origUrl = unescape(origUrl:match('[?&]url=([^&]+)')) end

	local uid = unescape(origUrl):match('%.carambatv%.ru/v/(%d+)')
	if not uid then
		page = usd.get('http://carambatv.ru/oembed/?url='..escapeUC(origUrl))
		data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
		uid = data.thumbnail_url:match('%.carambatv%.ru/v/(%d+)')
	end

	page = usd.get('http://video1.carambatv.ru/v/'..uid..'/videoinfo.js')
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data,nil,true))

	local title = utf8ToAnsi(data.title)
	script.tmp.newName = filterName(title, true)
	if setPusdName(script.tmp.newName) then return end

	local urls, info = {}, {}
	for k, v in ipairs(data.qualities) do
		local u = URI.combine('http://video1.carambatv.ru/v/'..uid..'/',v.fn)()
		usd.setreferer(origUrl)
		debugSaveInc(logpref..'.html', usd.head(u), v.height)
		local h = parseHeaders(usd.getheaders())
		if h.CODE==200 then
			urls[v.height] = u
			local size = h.SIZE and pad(('%0.2f'):format(h.SIZE / 1024 / 1024), 7, '  ') or ' ??????'
			table.insert(info, ('%s: %s MB'):format(pad(v.height,4,'  '), size))
			if fmt==v.height then break end
		end
	end

	if fmt then
		usd.setreferer(origUrl)
		usd.setretresult(urls[fmt], 0, 1)
		return
	end

	if not conf.interactive then
		for k, v in ipairs(conf.qualityList) do
			if urls[v] then
				fmt = v
				break
			end
		end
		fmt = fmt or next(urls)
		usd.modquery(origUrl..'#fmt='..fmt)
		usd.setreferer(origUrl)
		usd.setretresult(urls[fmt], 0, 0)
		return
	end

	local duration = s2hms((data.mid_ad_tag or ''):match('duration=(%d+)') or 0)
	local dlg = {
		{duration, title}
		, {'__________________________'}
		, {'Select quality:'}
		, {{type='select', name='quality', info }}
	}
	dlg = Dialog.new(dlg, script.name)
	local q = dlg:show()
	if q == '' then return end		-- esc
	q = q:match('quality=([%d]+)') + 1	--     0
	q = info[tonumber(q)]:match('^%s*(%d+):')
	fmt = tonumber(q)
	usd.modquery(origUrl .. '#fmt='..fmt)
	usd.setretresult(urls[fmt], 0, 0)
	return



end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( '//carambatv.ru/', GDL, OS)
