
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v21'
	--     html, script.name -       
	usd.setstatus(script.name)
	local dirUrl, page, uri
	script.tmp={}

	local cacheKey = origUrl
	local tmp = Cache.get(cacheKey)
	if tmp then
		script.tmp.newName = tmp.newName
		return
	end

	uri = URI.parse(origUrl)
	uri.path = uri.path:gsub('^/%w+(/files/)','%1'):gsub('^/%w+(/folders/)','%1')
	uri.host = 'dfiles.eu'

	local conf = Settings[script.name] or { addUa = false, captcha = 'recaptcha1' }
	debugLog(serialize(conf))

    local ua = conf.addUa
    	and not usd.ini.main.useragent:find('DepositFiles/FileManager')
    	and 'User-Agent: '..(conf.ua or usd.ini.main.useragent..' DepositFiles/FileManager 0.9.9.206' )

    if ua then setHeader(ua) end
	page = usd.get(uri())
    if ua then setHeader(ua, true) end
  	debugSaveInc(logpref..'.html', page)

	uri = URI.parse(usd.getlocation())

	if getHost(uri)=='gavitex.com' then return getMirror({usd.getlocation()}) end

  	if page:find('<span class="html_download_api-not_exists">',1,true) then
  		-- 1 -  , true -  plain text
  		usd.setretresult('%notfound%')
  		return
  	end

	usd.waittime(2,2)
	-- 2-4 

	local function checkDir(page)
		dirUrl = page:match('<td class="repeat"><a href="([^"]+)"')
		dirUrl = (dirUrl or ''):find('/auth-',1,true) and dirUrl
			or page:match("window.location.href%s*=%s*'(http://fileshare[^']+)'")
			or page:match('href="(http://fileshare%d+%.dfiles%.%w+/auth%-[^"]+)"')
		if not dirUrl then return end
		local tmp = dirUrl:match('/([^/]+)$')
		tmp = unescape(tmp)
		script.tmp.newName = utf8ToAnsi(tmp)
		usd.setretresult(dirUrl, math.random(3,5), 1)
		Cache.set(cacheKey, {dirUrl=dirUrl, cookie=usd.getcookie(), referer=referer, newName=script.tmp.newName})
		return true
	end

	if checkDir(page) then return end

	local folder = origUrl:match('/folders/(%w+)')
	if folder then
		page = usd.post(uri('/api/download/folder')(), '%simple%folder_id='..folder..'\nformat=json')
	  	local data = parseJsObject(utf8ToAnsi(page))
	  	debugSaveInc(logpref..'_folder.html', page, serialize(data or {},nil,true) )
	  	local h = uri('/files/')()
	  	for k, v in ipairs(data.data) do
			usd.addquery(('%s%s/%s#%sMb'):format(h, v.file_id, v.filename, ('%0.2f'):format(v.filesize/1024/1024)))
	  	end
	  	usd.setretresult('%done%')
	  	return
	end

	if ua then setHeader(ua) end
	page = usd.post(usd.getlocation(), '%simple%gateway_result=1')
    if ua then setHeader(ua, true) end
	--  
  	debugSaveInc(logpref..'.html', page)

  	if page:find('<span class="html_download_api-not_exists">',1,true) then
  		usd.setretresult('%notfound%')
  		return
  	end

  	if page:find('<span class="html_download_api-limit_parallel">',1,true) then
  		usd.setretresult('%simultaneous_downloads_limit')
  		return
  	end

	if checkDir(page) then return end

	local wait = string.match(page, '<span class="html_download_api%-limit_interval">(%d+)</span>')
		or page:match('<div class="ipbg">%s*<strong>[^<]- (%d+)')
	--      
	if wait then
		wait = tonumber(wait)
		if wait > 60 then
			usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
			--  USD ,   "%" -   
			return
		end
		usd.waittime(wait+math.random(1,3))
		page = usd.post(usd.getlocation(), 'gateway_result=1')
		debugSaveInc(logpref..'.html', page)
	end

	wait = string.match(page, '<span id="download_waiter_remain">(%d+)</span>')
	--     
	if not wait then
		--   ,   ...
		local err = page:match('<div class="ipbg">%s*<p>%s*<strong>.-</strong>')
		if err then
			err = err:gsub('%s*<br/>%s*', ' ')
			err = utf8ToAnsi(err)
			usd.setretresult('%' .. err)
			return
		end

		usd.setretresult('%plugindefect no wait')
		return
	end
	usd.waittime(wait)

	if checkDir(page) then return end

	local resp, _ , chall
	local fid = page:match('<td class="repeat"><a href="([^"]+)"')
	fid = uri(fid)()

	if conf.captcha=='recaptcha1' then
		resp, _ , chall = queryReCaptcha({key='6LdRTL8SAAAAAE9UOdWZ4d0Ky-aeA7XfSqyWDM2m', check=true})
		page = usd.get(fid .. '&challenge=' .. chall .. '&response=' .. resp)
	elseif conf.captcha=='recaptcha2' then
		resp = queryReCaptcha2({key='6LdyfgcTAAAAAArE1fk9cGyExtKfT4a12dWcViye', check=true})
		page = usd.get(fid .. '&challenge=null&response=null&g-recaptcha-response=' .. resp)
	elseif conf.captcha=='solvemedia' then
		resp, _ , chall = querySolvemedia({key='rQsco2pyUY4mMF.8s0ffsf5shFFyVIDI', check=true})
		page = usd.get(fid .. '&challenge=' .. chall .. '&response=' .. resp .. '&acpuzzle=1')
	end

	debugSaveInc(logpref..'.html', page)

  	if page:find('load_recaptcha()',1,true) then return usd.setretresult('%Wrong captcha?') end

	if checkDir(page) then return end

	usd.setretresult('%plugindefect end')
end


--        ,
--       PlgOnSuccess
function OS(origUrl, dirUrl, fullName)
	Cache.del(origUrl)
	local newName = fileRename(fullName, script.tmp.newName)
	-- fileRename       / 

	usd.setretresult(newName)
	return
end

regDirSuccess('//depositfiles.com/', GDL, OS)
regDirSuccess('//depositfiles.org/', GDL, OS)
regDirSuccess({'//dfiles.ru/','.dfiles.ru/'}, GDL, OS)
regDirSuccess({'//dfiles.eu/','.dfiles.eu/'}, GDL, OS)
regDirSuccess('//depositstorage.com/', GDL, OS)
--     '//depositfiles.com/' 
--     -  GDL - 
-- ,      - OS
