--GDL

local conf = Settings[script.name] or { }
conf.qualityList = conf.qualityList or {"1080p", "720p", "360p"}
local fGzip = conf.gzip
local hGzip = {
	'Accept-Encoding: deflate, gzip, x-gzip, identity, *;q=0'
	--,'TE: gzip, chunked'
	--,'TE: deflate, gzip, chunked, identity, trailers'
}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v13'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri, data
	local resumeFlag = 1
	script.tmp={}

	debugLog(serialize(conf,nil,nil,true))

	Storage[script.name] = Storage[script.name] or {}
	local st = Storage[script.name]

	uri = URI.parse(origUrl)
	local oldOrig = origUrl

	local artid
	if uri.fragment then
		artid = uri.fragment:match('^/d(%w+)$')
		if artid then
			artid = artid and tonumber(artid, 36)
			origUrl = 'http://www.deviantart.com/view/'..artid
			uri = URI.parse(origUrl)
		end

		if not artid then
			artid = uri.fragment:match('^[^?]*'):match('^/art/.-%-(%d+)$')
			if artid then
				origUrl = 'http://www.deviantart.com/view/'..artid
				uri = URI.parse(origUrl)
			end
		end
	end

	artid = artid
		or uri.path:match('^/art/[^/]-%-(%d+)$')
		or uri.path:match('^/journal/[^/]-%-(%d+)$')
		or uri.path:match('^/download/(%d+)')
		or uri.path:match('^/view/(%d+)')
		or uri.path:match('^/deviation/(%d+)')
		or uri.path:match('^/embed/film/(%d+)')
		or uri.host:find('%.deviantart%.net$') and tonumber(uri.path:match('%-d(%w+)%.%w+$') or '', 36)

	if not artid then
		artid = uri.host=='fav.me' and tonumber(uri.path:match('^/d(%w+)$') or '', 36)
		if artid then
			origUrl = 'http://www.deviantart.com/view/'..artid
			uri = URI.parse(origUrl)
		end
	end
	artid = tonumber(artid)

	local fmt = origUrl:match('#fmt=(%w+)$')
	origUrl = origUrl:match('^[^#]+')

	local trimCharset = re.compile('[%s _ . ~ -]')
	local function filter2(str)
		--return trim(str:gsub('[%[,(%s]*[Cc]om+is+ion[%])%s]*',' '):gsub('%[[Cc]omic%]',' '), trimCharset)
		return trim(str, trimCharset)
	end

	if origUrl:find('.deviantart.com/journal/',1,true) then return usd.setretresult('%notfound%') end

	if origUrl:find('//sta.sh/') then
		debugSaveInc(logpref..'.html', usd.head(origUrl))
		if parseHeaders().CODE==404 then return usd.setretresult('%notfound%') end
		origUrl = usd.getlocation()	-- redirect to deviantart.com
	end

	local function fixCookies()
		local c = splitKV(usd.getcookie(),'=',';')
		for k, v in pairs(c) do if v=='deleted' or (k=='q' and v=='0') then c[k]=nil end end
		usd.setcookie(tableConcat(c,'=','; '))
	end


	usd.setcookie('agegate_state=1')

	local acc = Accounts['deviantart.com']
	--if script.cookie then
	--	usd.setcookie(script.cookie)

	local function checkAcc(page)
		if acc and not page:find('www.deviantart.com/users/logout') then
			if parseHeaders().CODE~=200 then return false end
			st["<cookie>"] = nil;
			--local tmp = 'Invalid account?';
			local tmp = 'logged out?';
			usd.setstatus(tmp)
			usd.savetolog(tmp)
			usd.setretresult('%'..tmp)
			return false
		end
		return true
	end


	if st["<cookie>"] then
		usd.setcookie(st["<cookie>"])
	elseif acc then
		--page = usd.get('http://l.deviantart.com/')
--fGzip=true
		page = urlGet('http://l.deviantart.com/', {https='Proxomitron', gzip = fGzip, fixCookies=fixCookies})
		debugSaveInc(logpref..'.html', page)
		fixCookies()
		usd.waittime(2,2)
		form = page:match('<form[^>]-/users/login.-</form>')
		form = Form.parse(form)
		--form.action='https://www.deviantart.com/users/login'
		form.inputs.username = acc[1].login
		form.inputs.password = acc[1].password
		form.inputs.remember_me = 1
		form.inputs.ref = 'http://www.deviantart.com/browse/all/'
		--page = form:submit()
		page = urlGet(form.action, {https='Proxomitron', post = form:getinputs(), gzip = fGzip, fixCookies=fixCookies})
		debugSaveInc(logpref..'_login.html', page)
		fixCookies()
		if checkAcc(page) then st["<cookie>"] = usd.getcookie() end
		usd.waittime(2,2)
	end


	if uri.path:find('^/print/') then
		--page = usd.get(origUrl)
		page = urlGet(origUrl, {gzip = fGzip, fixCookies=fixCookies})
		debugSaveInc(logpref..'.html', page)
		checkAcc(page)

		local tmp = page:match('href="([^"]+)">View Deviation</a>')
		if not tmp then return usd.setretresult('%not supported: print') end
		usd.modquery(tmp)
		origUrl = tmp
		uri = URI.parse(origUrl)
	end


	if not artid and uri.host:find('%.deviantart%.net$') then
		debugLog('direct?')
		usd.setretresult(origUrl,0,1)
		return
	end

	if artid and (not (uri.host:find('%.deviantart%.com$') or uri.host=='fav.me') or uri.host=='backend.deviantart.com') then
		debugSaveInc(logpref..'.html', usd.head('http://www.deviantart.com/view/'..artid) )
		if not parseHeaders().CODE==200 then
			dirUrl = origUrl
			dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)PRE/','http://fc%1')
			dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)%d+[HW]?/','http://fc%1')
			usd.setretresult(dirUrl,0,1)
			return
		end
		origUrl = usd.getlocation()
		uri = URI.parse(origUrl)
	end

	if uri.path:find('^/view/') then
		debugSaveInc(logpref..'.html', usd.head('http://www.deviantart.com/view/'..artid) )
		if parseHeaders().CODE==404 then
			if getHost(oldOrig,nil,nil,2)=='deviantart.net' then
				debugSaveInc(logpref..'.html', usd.head(oldOrig))
				if parseHeaders().CODE==200 then return usd.setretresult(oldOrig,1,1) end
			end
			return usd.setretresult('%notfound%')
		end
		origUrl = usd.getlocation()
		uri = URI.parse(origUrl)
	end

	local userid = uri.host:match('^([^.]+)')
	local gallery = uri.path:match('^/gallery/(%d+)') or (uri.query or ''):match('set=(%d+)')
	local favourites = uri.path:match('^/favourites/')
	local category = (uri.query or ''):match('catpath=%%2F(%w+)')

	local limits = (conf.customLimits or {})[userid] or {}
	if not limits['<all>'] then limits = tableCombine(conf.maxFileSize or {}, limits) end
	debugLog('limits = '..serialize(limits,nil,nil,true))

	if uri.host=='sta.sh' then
	    --page = usd.get(origUrl)
	    page = urlGet(origUrl, {gzip = fGzip, fixCookies=fixCookies})
		debugSaveInc(logpref..'.html', page)

		if page:find('stash-thumb-container',1,true) then
			for tmp in page:gmatch('(stash%-thumb%-container.-</span></div></div>)') do
				local title1 = tmp:match('flat_title="([^"]+)"')
				local title2 = tmp:match('<h2>([^<]-)</h2>')
				title2 = title2 and '-'..title2 or ''
				local url = tmp:match('href="([^"]+)"')
				usd.addquery(url..'#'..filterName(utf8ToAnsi(title1..title2), true))
			end
			usd.setretresult('%done%')
			return
		end

		--local title = page:match('<meta property="og:title" content="([^"]+)">')

		dirUrl = page:match('href="(http://sta.sh/download/[^"]+)"')
		if dirUrl then
			debugSaveInc(logpref..'.html', usd.head(entityDecode(dirUrl)))
			dirUrl = usd.getlocation()
		end
		--local page2 = usd.get('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl))
		local page2 = urlGet('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl), {gzip = fGzip})
        data = parseJsObject(page2) or {}
		debugSaveInc(logpref..'.html', page2, serialize(data, nil, true))
		fixCookies()
		if data.type=='rich' and not dirUrl then	-- html
			debugLog('not supported: rich')
			usd.setretresult('%notfound%')
			return
		end

		dirUrl = dirUrl	or data.url	or data.fullsize_url
		dirUrl = dirUrl:gsub('^[^/]+//[thfc]+(%d+%.deviantart%.net/fs%d+/)PRE/','http://fc%1')
		--script.tmp.newName = filterName( utf8ToAnsi(data.author_name..'-'..trim(data.title, re.compile('[%s _ . -]'))..dirUrl:match('%.[^./]+$')), true)
-- "[Commission]"
		--script.tmp.newName = filterUtf8(data.author_name..'-'..filter2(data.title or title))
		script.tmp.newName = filterUtf8(data.author_name..'-'..filter2(tostring(data.title)))
		--dirUrl = addNewName(dirUrl, script.tmp.newName, nil, nil, -1)
		debugLog(script.tmp.newName)
		usd.setreferer(origUrl)
		usd.modquery(origUrl)
		usd.setretresult(dirUrl, 0, 1)
		return
	end

	if not artid then	-- gallery
		local offset = tonumber( (uri.query or ''):match('offset=(%d+)') or 0 )
		local nextPage, getAllPics
		local skippedOld = 0 --     

		if uri.path=='/rss.xml' then
			nextPage = origUrl
		else
			uri.query = uri.query and uri.query:gsub('[&?]?offset=%d*','')
			if uri.path=='/' then uri.path='/gallery/' end

			if (uri.path=='/gallery/' or uri.path=='/favourites/') and not uri.query then	uri.query='catpath=%2F'	end
			origUrl = uri()

			if uri.path=='/gallery/' and unescape(uri.query or '')=='catpath=/' then getAllPics = true end

			local query = 'sort:time '..(favourites and 'favby:' or 'gallery:')..userid..(gallery and '/'..gallery or '')..(category and ' in:'..category or '')
			nextPage = 'http://backend.deviantart.com/rss.xml?q='..escapeUC(query)..'&type=deviation&offset='..offset
		end

		if conf.rememberGreaterID and st[userid] then debugLog('Greater ID: '..st[userid]) end


		while nextPage do
			--page = usd.get(nextPage)
			page = urlGet(nextPage, {gzip = fGzip, fixCookies=fixCookies})
			debugSaveInc(logpref..'.html', page, 'gallery page', false)
			if usd.progstatus()==0 then return end

			local nextPage2
			if not page:find('<guid[^>]+>') then
				nextPage2 = 'http://'..userid..'.deviantart.com/gallery/'..(gallery or '?catpath=/')
				while nextPage2 do
					if usd.progstatus()==0 then return end
					--page = usd.get(nextPage2)
					page = urlGet(nextPage2, {gzip=fGzip})
					debugSaveInc(logpref..'.html', page, 'gallery page [2]')
					if page:find('<title>Deactivated Account - DeviantArt</title>',1,true) then return usd.setretresult('%notfound%') end
					if not checkAcc(page) then return end
					local h = parseHeaders()
					if h.CODE~=200 then	return usd.setretresult('%'..(h.CODE==404 and 'notfound%' or h.REASON or h.CODE or 'bad headers?'),math.random(10,40)) end
					fixCookies()
					for url in (page:match('name="gmi%-ResourceStream".-<div id="gallery_pager"') or ''):gmatch('<span class="details" ><a href="([^"]+)"') do
						local num = url:match('%-(%d+)$')
						if tonumber(num) > (getAllPics and conf.rememberGreaterID and st[userid] or 0) then
							usd.addquery(uri(entityDecode(url))())
						else
							skippedOld = skippedOld + 1
						end
					end
					if skippedOld >= 100 then	-- 60
						nextPage2 = nil
						debugLog('Old deviations was skipped (2)')
						break
					end
					nextPage2 = page:match('<div class="pagination"><ul class="pages">.-</span></a></li></ul></div></div>')
					nextPage2 = (nextPage2 or ''):match('<li class="next"><a class="away"[^>]-href="([^"]+)"')
					nextPage2 = nextPage2 and entityDecode(nextPage2)
				end
				--break
			else
				for url in page:gmatch('<guid[^>]+>([^<]+)</guid>') do
	    			if getAllPics and conf.rememberGreaterID then
						local num = url:match('%-(%d+)$')
						if tonumber(num) > (st[userid] or 0) then
							usd.addquery(entityDecode(url))
						else
							skippedOld = skippedOld + 1
						end
					else
						usd.addquery(entityDecode(url))
					end
				end
			end

			if usd.progstatus()==0 then return end

			if skippedOld >= 50 then	-- 60
				nextPage = nil
				debugLog('Old deviations was skipped')
				break
			end

			nextPage = not nextPage2 and page:match('<atom:link rel="next" href="([^"]+)"')
			if nextPage then
				nextPage = entityDecode(nextPage)
				offset = nextPage:match('offset=(%d+)')
				uri.query = (uri.query or ''):gsub('&?offset=%d*','')
				uri.query = uri.query..(#uri.query>0 and '&' or '')..'offset='..offset
				usd.modquery(uri())
				usd.waittime(1)
			end
		end

		if not nextPage then
			uri.query = (uri.query or ''):gsub('&?offset=%d*','')
			if uri.query=='' then uri.query=nil end
			usd.modquery(uri())
			usd.setretresult('%done%')
		end
		return
	end	-- gallery

	local picData = {embed={}, oembed={}}	--username, title
	--page = usd.get('http://backend.deviantart.com/embed/info.php?id='..artid)
	page = urlGet('http://backend.deviantart.com/embed/info.php?id='..artid, {gzip = fGzip})
	debugSaveInc(logpref..'.html', page)
	fixCookies()
	if page:find('/images/150/shared/poetry.jpg') then return usd.setretresult('%notfound%') end
	local err = page:match('^GET Error: ([%C]+)')
	if err then return usd.setretresult('%'..err,10) end

	for k, v in page:match('^<%?xml.-<array>(.-)</array>%s*$'):gmatch('<([^>]+)>(.-)</%1>') do picData.embed[k]=v:gsub('^<!%[CDATA%[(.-)%]%]>$','%1') end
	picData.isVideo = (picData.embed.onefifty or ''):find('[^/]+//[^/]+/[^/]+/film/')

	if picData.isVideo then
		usd.setreferer('')
		--local pagev = usd.get('http://backend.deviantart.com/embed/film/'..artid..'/1/')
		--picData.page = usd.get(origUrl)
		picData.page = urlGet(origUrl, {gzip = fGzip, fixCookies=fixCookies})
		data = picData.page:match('gmon%-sources="([^"]+)"')
		data = parseJsObject(entityDecode(data))
		if picData.embed.fileurl then data.orig={src=picData.embed.fileurl} end
		debugSaveInc(logpref..'.html', picData.page, serialize(data or {},nil,true))
		if not checkAcc(picData.page) then return end
		local h = parseHeaders()
		if h.CODE~=200 then	return usd.setretresult('%'..(h.CODE==404 and 'notfound%' or h.REASON or h.CODE or 'bad headers?'),math.random(10,40)) end
-- qualityList, interactive

		local title = utf8ToAnsi(entityDecode(entityDecode(picData.page:match('<title>(.-)</title>')))):gsub('&','&&')
		local duration = (function(n) return ('%02d:%02d:%02d'):format(math.floor(n/60/60),math.floor((n/60)%60),n%60) end)((picData.page:match('"duration":"(%d+)"') or 0)/1000)

		if fmt and data[fmt] then
			dirUrl = data[fmt].src
		else
			resumeFlag=0

			if conf.interactive then
				local info = {}
				for k, v in ipairs(conf.qualityList) do
					if data[v] then
						debugSaveInc(logpref..'.html', usd.head(data[v].src))
						local size = parseHeaders(usd.getheaders()).SIZE
						size = size and ('%0.2f'):format(size / 1024 / 1024) or ' ??????'
						local f = v=='orig' and '    '..v or v
						table.insert(info, ('%s: %s MB'):format(pad(f,5,'  '), pad(size,7,'  ')))
					end
				end

				local dlg = {
					{duration, title}
					, {'__________________________'}
					, {'Select quality:'}
					, {{type='select', name='quality', info }}
				}
				dlg = Dialog.new(dlg, script.name)
				if usd.progstatus() == 0 then
					debugLog('USD stopped')
					return
				end
				local q = dlg:show()
				if q == '' then debugLog('Esc') return end		-- esc
				q = tonumber(q:match('quality=([%d]+)')) + 1	--     0
				fmt = info[q]:match('^%s*([^:]+)')
				dirUrl = data[fmt].src
			else
				for k, v in ipairs(conf.qualityList) do
					if data[v] then
						dirUrl = data[v].src
						fmt = v
					end
				end
			end
			uri.fragment='fmt='..fmt
			usd.modquery(uri(nil,true))
		end
	end	-- isVideo

	--picData.urls = {orig=picData.embed.fileurl} -- orig, img, pre

local function getSmaller(url, str)
	if not conf.maxFileSize or picData.isVideo then debugLog('getSmaller(): skip check') return false end
	ctype = (url:match('%.(%w+)$') or ''):lower() -- content-type   'text/html'
	debugLog('getSmaller(): type='..serialize(ctype))
	--local maxSize = conf.maxFileSize[ctype] or conf.maxFileSize.other or math.huge
	local maxSize = limits['<all>'] or limits[ctype] or limits.other or math.huge
	if maxSize==math.huge then debugLog('getSmaller(): skip check'); return false end
	if maxSize==0 then
		debugLog('skip: maxSize='..maxSize)
		return true
	end
	debugSaveInc(logpref..'.html', usd.head(url), str)
	local headers = parseHeaders(usd.getheaders())
	local size = headers.SIZE or math.huge
	debugLog('size='..size..', maxSize='..maxSize)
	if (size > maxSize) or headers.CODE~=200 then
		if conf.convertGif and ctype=='gif' then
			local mp4 = convertGif(url, maxSize)
			if mp4 then return false, mp4 end
		end
		return true, url
	end
	return false, url
end

	--local tooBig, code = true, 200
	local tooBig = true
	local newDirUrl
	local smPref = ''
	if not (picData.isVideo or picData.embed.error=='Deviation not found' or picData.embed.fileurl:find('^s%d+orig:') --[[flash]] ) then
		dirUrl = dirUrl or picData.embed.fileurl
		if dirUrl:find('^(fs%d+):') then dirUrl = dirUrl:gsub('^(fs%d+):', picData.embed.onefifty:match('^(http://[^/]+/)')..'%1/') end
		--picData.embed.fileurl = dirUrl
		if dirUrl then tooBig, newDirUrl = getSmaller(dirUrl, 'embed') end
		if tooBig then smPref = 'sm-' end
	end

	if tooBig and not picData.isVideo then
		usd.setreferer('')
		--local page = usd.get('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl))
		local page = urlGet('http://backend.deviantart.com/oembed?url='..escapeUC(origUrl), {gzip = fGzip})
		picData.private = page:find('Deviation id %d+ is private')
	    picData.oembed = parseJsObject(page) or {category=''}
		debugSaveInc(logpref..'.html', page..'\r\n', serialize(picData.oembed, nil, true))
		fixCookies()
		if page:find('404 Not Found .- Deviation id %d+ is deleted')
			or (picData.oembed.url or ''):find('/images/150/shared/poetry.jpg')
			then return usd.setretresult('%deleted%') end
		usd.setreferer('')
		--picData.page = usd.get(origUrl)
		picData.page = urlGet(origUrl, {gzip = fGzip, fixCookies=fixCookies})
		debugSaveInc(logpref..'.html', picData.page, 'picData.page')
		if not checkAcc(picData.page) then return end
		local h = parseHeaders()
		if h.CODE~=200 then	return usd.setretresult('%'..(h.CODE==404 and 'notfound%' or h.REASON or h.CODE or 'bad headers?'),math.random(10,40)) end

		if parseHeaders().CODE==404 then return usd.setretresult('%notfound%') end

		if usd.getlocation():find('.deviantart.com/journal/',1,true) then return usd.setretresult('%notfound%') end

		picData.title = picData.oembed.title or picData.page:match('<meta name="og:title" content="([^"]+)"')

		--dirUrl = picData.oembed.url:gsub('(/fs%d+/)PRE/','%1')

		dirUrl = picData.page:match('tumblr%.com/share/photo%?source=([^&"]+)')
		dirUrl = dirUrl and unescape(dirUrl)

		dirUrl = dirUrl
			or ((picData.oembed.url or origUrl):lower()~=origUrl:lower()) and picData.oembed.url
			or picData.oembed.fullsize_url
			or picData.page:match('<meta property="og:image" content="([^"]+)"')

		--local err = picData.page:match('<div id="filter%-warning" class="antisocial">%s*<h3>(.-)</h3>')
		--err = err and trim((err:gsub('<[^>]+>',' '):gsub('%s+',' ')))
		--if err and not dirUrl then return usd.setretresult('%'..err) end

		if not dirUrl and picData.oembed.category:find('^Literature') then return usd.setretresult('%notfound%') end

		local flash = picData.page:find('href="http://www.deviantart.com/browse/all/flash/"',1,true)
		local dl = picData.page:match('http://www.deviantart.com/download/[^"]+')
		if dl then
			if fGzip then setHeader(hGzip) end
			debugSaveInc(logpref..'.html', usd.head(entityDecode(dl)), 'dl')
			if fGzip then setHeader(hGzip, true) end
			dirUrl = usd.getlocation()
		end
		if flash then
			smPref = ''
			local sb = picData.page:match('src="(http://sandbox.deviantart.com[^"]-.swf)"')
			if sb then
				--sb = usd.get(URI.recode(sb))
				sb = urlGet(URI.recode(sb), {gzip = fGzip})
				debugSaveInc(logpref..'.html', sb)
				fixCookies()
				dirUrl = sb:match('<embed[^>]-src="([^"]+)"')
			end
			if not (dirUrl or ''):find('.swf',1,true) then return usd.setretresult('%.swf not found') end
		end

		tooBig, newDirUrl = getSmaller(dirUrl, 'orig?')
		if tooBig then
			smPref = 'sm-'
			--picData.title = 'sm-'..(picData.title or '')
			local tmp = picData.page:match('<div class="dev%-view%-deviation">.-</div>')
			local full = ((tmp or ''):match('<img[^>]-dev%-content%-full[^>]+>') or ''):match('src="([^"]+)"') or picData.oembed.fullsize_url
			local pre = ((tmp or ''):match('<img[^>]-dev%-content%-normal[^>]+>') or ''):match('src="([^"]+)"')
				--or picData.page:match('><i></i><img[^>]-data%-src="([^"]+)"'):gsub('^https?://th(%d+%.deviantart%.net/fs%d+/)150/','http://fc%1PRE/')
				or picData.page:match('data%-src="([^"]+)"')
			dirUrl = full or picData.oembed.url	or picData.page:match('><i></i><img[^>]-data%-src="([^"]+)"'):gsub('^https?://th(%d+%.deviantart%.net/fs%d+/)150/','http://fc%1')
			tooBig, newDirUrl = getSmaller(dirUrl, 'img?')
			if tooBig then
				--debugSaveInc(logpref..'.html', usd.head(pre))
				--if parseHeaders(usd.getheaders()).code==200 then dirUrl = pre end
				dirUrl = pre
				tooBig, newDirUrl = getSmaller(dirUrl, 'pre?')
				if tooBig then
					newDirUrl = picData.embed.threehundred or picData.oembed.thumbnail_url
				end
			end
		end
		picData.username = uri.host:match('^([^.]+)')
	end
	dirUrl = newDirUrl or dirUrl

--http://th04.deviantart.net/images/150/shared/poetry.jpg
	if (dirUrl or ''):find('/images/150/shared/poetry.jpg') then return usd.setretresult('%notfound%') end

	--debugSaveInc(logpref..'.html', serialize(picData,nil,true), nil,  false)

	picData.username = picData.username or picData.embed.username or picData.oembed.author_name
	picData.title = smPref..entityDecode((picData.title or picData.embed.title or picData.oembed.title or (picData.page or ''):match('<title>(.-)</title>')) or '')

	if conf.rememberGreaterID and artid > (st[userid] or 0) then st[userid] = artid end

	script.tmp.newName = filterName(utf8ToAnsi(('%s-%s-%s'):format(picData.username, pad(artid,9), filter2(picData.title))), true)
	debugLog(script.tmp.newName)
	--local fext = isVideo and dirUrl:find('%.jpg$') and '.mp4' or dirUrl:match('%.[^.]+$')
	--dirUrl = addNewName(dirUrl, script.tmp.newName, nil, nil, fext)
	usd.modquery(origUrl)
	usd.setretresult(dirUrl, 0, resumeFlag)

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, getProperExt(fullName) or -1))
end

function SU(url)
	local uri = URI.parse(url)
	if uri.fragment then
		if uri.fragment:find('^/art/') or uri.fragment:find('^/d[%da-z]+$') then return false end -- single
	end
	if tableContains({'sta.sh','fav.me','deviantart.net'}, getHost(uri,nil,nil,2))
		or uri.path:find('^/view/%d+')
		or uri.path:find('^/art/')
		then return false
	end
	if (uri.path or '/')=='/' or uri.path:find('^/gallery') then
		return true
	end
end

regDirSuccess( {'.deviantart.com/','.deviantart.net/','//sta.sh/', '//fav.me/'}, GDL, OS, SU)
