local conf = tableCombine({mirrors={},referers={}},Settings[script.name] or {})

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v05'
	debugLog(logpref)
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	if origUrl:find('^ftp://directs?/') then origUrl = origUrl:gsub('^ftp://direct(s?)/(.+)$','http%1://%2') end

	uri = URI.parse(origUrl)

	local acc = Accounts[getHost(uri)]
	if uri.userinfo or acc then
		local tmp = uri.userinfo and split(uri.userinfo, ':') or {acc[1].login, acc[1].password}
		setHeader('Authorization: Basic '..base64.encode((tmp[1] or '')..':'..(tmp[2] or '')))
	end

	dirUrl = uri()

	if conf.referers[getHost(uri)]~=false then usd.setreferer(conf.referers[getHost(uri)] or dirUrl) end
	usd.setretresult(dirUrl, 1, 1)
end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	local newName = dirUrl:match('[?&]/([^?&/]+)$')
	if not newName then
		newName = parseHeaders().FILENAME
		newName = newName and filterUtf8(newName)
	end
	if newName then return usd.setretresult(fileRename(fullName, newName)) end
end


regDirSuccess( {'ftp://direct/','ftp://directs/'}, GDL, OS)
regDirSuccess( conf.mirrors, GDL, OS)
