
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={parts={},files={}}
	local parts, files = script.tmp.parts, script.tmp.files
	local sizes = {}

	local conf = Settings[script.name] or {interactive = false, qualityList = {'720p', '480p', '360p'} }
	debugLog(serialize(conf,nil,nil,true))

	local fmt = origUrl:match('#fmt=(%w+)')

	uri = URI.parse(origUrl)
	origUrl = uri()

	local id = origUrl:match('[?&]record_id=(%d+)')

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	page = usd.get(uri('/api/player_data?id='..id)())
	local data =parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil, true))

	data = data.data.playlist.viewports[1].medialist[1]
	local title = utf8ToAnsi(data.title)
	script.tmp.newName = filterName(title, true)
	local duration = s2hms(data.duration)
	local snapshot = uri(data.snapshot)()

	page = usd.get(uri(data.sources.secure_m3u8.auto)())
	local data =parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil, true))

	page = usd.get(data.data[1])
	debugSaveInc(logpref..'.html', page)

	local PLs = {}
	for u in page:gmatch('[\r\n](http:/%S+)') do
		local q = u:match('_(%d+p)%.mp4/index')
		PLs[q] = u
		sizes[q] = {}
	end
	debugSaveInc(logpref..'.html', serialize(PLs,nil,true),'qualities',false)

	if not fmt then
		for k, v in ipairs(conf.qualityList) do
			if PLs[v] then
				fmt = v
				break
			end
		end
	end

	usd.modquery(origUrl..'#fmt='..fmt)
	local playlist = PLs[fmt]
	uri = URI.parse(playlist)

	page = usd.get(playlist)
	debugSaveInc(logpref..'.html', page)

	local tempDir = Settings['<misc>'].tempDir or getLstInfo().saveto
	for u in page:gmatch('[\r\n](%w%S+)') do
		table.insert(parts, uri(u)())
		table.insert(files, ('%s%s_%s_%s.ts'):format(tempDir,script.name,id,pad(#files+1,3)))
	end
	debugSaveInc(logpref..'.html', serialize({parts=parts,files=files},nil,true),'parts',false)

	for i=1, #parts do
		local msg = 'downloading part '..i..'/'..#parts
		debugLog(msg)
		usd.setstatus(msg)
		local fsize = fileSize(files[i])
		if not fsize or fsize ~= (sizes[fmt][i] or parseHeaders(usd.head(parts[i])).SIZE) then
			usd.setreferer(origUrl)
			usd.get(parts[i]..'|'..files[i])
		end
	end

	usd.setreferer(origUrl)
	usd.setretresult(snapshot,0,0)
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'

	debugLog('Joining...')
	local parts, files = script.tmp.parts, script.tmp.files

	local h, err = io.open(fullName,'wb') -- playlist
	if err then
		usd.savetolog(err)
		return
	end

	for i=1, #files do
		usd.setstatus('joining part '..i..'/'..#parts)
		h:write(fileRead(files[i]))
	end
	h:close()

	debugLog('Deleting parts...')
	for i=1, #files do os.remove(files[i]) end

	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.ts'))
end


regDirSuccess( '.media.eagleplatform.com/index/player', GDL, OS)
