
function GDL(origUrl) 	-- GetDirectLink
	usd.setstatus(script.name)
	logpref = script.name .. '_GDL_v07'

--[[
usdLua_settings.lua:

Settings['embedupload_com'] = { interactive = false, direct = false, remember = false  }

interactive -    
direct -     embedupload;  ,    
remember -  ,  m.lua

]]

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false, direct = false, remember = false }
	end

	origUrl = origUrl:match('^([^#]+)')

	script.tmp={}
	usd.setstatus(script.name)
	local page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('class="form%-title"[^>]+>%s*([^<]-) <')
	if err == 'Removed for copyright infringement or Invalid file name' then return usd.setretresult('%notfound%') end

	usd.waittime(3, 3)

	local name, size = page:match('class="form%-title"[^>]+>%s*(.-)%s*<div class="grey%-text">%s*%(([^<]-)%)')
	name = name:gsub(' <br>','')

	local dirUrl = page:match('href="(http://www.embedupload.com/%?EU=[^"]+)"')

	if dirUrl and conf.direct then
		usd.setreferer(dirUrl)
		--if name then
		--	dirUrl = addNewName(dirUrl, utf8ToAnsi(name))
		--end
		usd.setretresult(dirUrl, math.random(2,4), 1)
		return
	end

	usd.relocationmode(0)
	local mirrors = {}
	for url in page:gmatch('<a href="([^"]+)" target="_blank" class="DownloadNow">') do
		usd.waittime(1)
		local page = usd.get(url)
		debugSaveInc(logpref..'.html', page)
		local tmp = usd.getheaders() .. page
		local u

		u = page:match('Location: ([^%s]+)', 2)
			or page:match('class="categories"[^>]*>%s*<span>%s*<b>.-(http[^<%s\'"]+)')

		if u then
			table.insert(mirrors, u)
		else
			usd.savetolog('Error: url was not found')
		end
	end

	if page:find('class="DownloadNow"') and not next(mirrors) then	-- empty table
		usd.setretresult('%No mirrors?')
		return
	end

	if conf.remember then
		local data = {orig = origUrl, mirrors=mirrors, name=name, size=size}
		local mHandler, data = serializeMirrors(data)
		if mHandler then
			usd.modquery(data)
			mHandler(data)
			return
		end
	end

	local status, mirror = getMirror(mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows={ {'Name: '..(name or 'noname')}, {'Size: '..(size or 'nosize')} } } )
	if status then script.tmp.mirror = mirror end

	return
end

function OS(origUrl, dirUrl, fullName)
	local EU = fullName:match('\\EmbedUpload%.com_(.+)$')
	if EU then
		return usd.setretresult(fileRename(fullName, EU))
	end

	if not (script.tmp and script.tmp.mirror) then return end
	local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	if OShandler then
		if h then debugLog('substring: '..h) end
		OShandler(script.tmp.mirror, dirUrl, fullName)
		return
	end
	debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end

-- c   Content-Length  USD     .
function OC(dirUrl, fullName, headers, currStatus)
	if currStatus == 2 then
		local function fileSize(fname)
			local h, err = io.open(fname, 'r')
			if not h then return nil, err end
			local s = h:seek("end")
			h:close()
			return s
		end

		local hl = headers:lower()
		if hl:find('http/1.1 206 partial content',1,true) then
			local size1 = headers:match('content%-range: bytes %d+%-%d+/(%d+)')
			if not size1 then return end
			size1 = tonumber(size1)
			local size2 = fileSize(fullName)
			debugLog('size1 = '..size1)
			debugLog('size2 = '..size2)
			if size1 ~= size2 then
				usd.setretresult(1)	-- '1' - cPart
			end
		end
	end
end

regDirSuccess( 'embedupload.com/?d=', GDL, OS)
regCheckError( 'embedupload.com/?EU=', OC )
