
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v09'
	usd.setstatus(script.name)

	local page, dirUrl, form

	function head(url)
		local h
		local l = url
		usd.relocationmode(0)
		for i=1, 22 do
			h = usd.head(l)
			debugSaveInc(logpref..'.html', '', 'head: '..i)
			l = h:match('%sLocation: ([^\r\n]+)')
			if not l then break end
			if l:find('^/') then l = usd.getlocation():match('^([^/]+//[^/]+)') .. l end
		end
		usd.relocationmode(1)
		return h
	end

	page = head(origUrl)

	if page:find('Content-Disposition: attachment;',1,true) then
		usd.setretresult(usd.getlocation(), 1, 1)
		return
	end

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	local err = page:match('<ul id="notifications">.-<p>(.-)</p>')
		or page:match('<p class="info">[^<]-(Premium account holders only)')
		or page:match('<div class="alert alert%-%w+">%s*<h2>(.-)</h2>')
	if err then
		err = err:gsub('<[^>]+>', ' '):gsub('%s%s+', ' '):gsub('^%s*(.-)%s*$','%1')
		usd.savetolog(err)
		if err:find('Sorry, this file is no longer available',1,true)
			or err:find('Invalid Download Link')
			or err:find('This file has been deleted.',1,true)
			or err:find('Premium account holders only')
			or err:find('Premium Account Required')
			then
			err = 'notfound%'
		end
		usd.setretresult('%'.. err)
		return
	end

	script.tmp={}
	--script.tmp.newName = page:match('<div id="main".-<div id="crumbtrail">.-<span class="last">([^<]+)</span>')

	usd.waittime(2, 2)

	dirUrl = page:match('http://%w+.filefactory.com/dlp/[^/]+/[^/]+/[^%s\'"]+')
	if dirUrl then
		head(dirUrl)
		usd.setretresult(usd.getlocation(), 1, 1)
		return
	end

	local key = page:match('Recaptcha%.create%(%s*"([^"]+)"')
	local tmp = page:match('if%($%("#recaptcha_response_field"%).-success:')

	if tmp then
		form = '<form method=POST action="'..origUrl:match('^[^/]+//[^/]+')..tmp:match('url: "([^"]+)",') ..'"><input name=check value='..tmp:match("check: '([^']+)'")..'></form>'
		form = Form.parse(form)

		form.inputs.recaptcha_response_field
			, _, form.inputs.recaptcha_challenge_field
				= queryReCaptcha(key, 0, nil, nil, nil, true)
		page = form:submit()
		debugSaveInc(logpref..'.html', page)

		local data = parseJsObject(page)
		if data.status == 'fail' then
			usd.setretresult('%' .. data.message)
			return
		end

		local path = data.path
		page = usd.get(path)
		debugSaveInc(logpref..'.html', page)
	end

	local tmp = page:match("(/dlf/f/[^\r\n'\"]+)")
	if tmp then
		usd.waittime(3,3)
		page = usd.get(URI.combine(origUrl, tmp)())
		debugSaveInc(logpref..'.html', page)
	end

	if page:find('storebox%d*%.info') or page:find('zilliontoolkit') then
		local msg = getHost(usd.getlocation())..': Trojan accelerator detected!'
		usd.setstatus(msg)
		usd.savetolog(msg)
	end

	local wait = tonumber(page:match('<span class="countdown">(%d+)</span>') or 60)
	if wait > plg.config.maxwait then
		usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
		return
	end
	usd.waittime(wait+2, 2)

	--dirUrl = page:match('id="downloadLinkTarget".-<a href="([^"]+)"')
	dirUrl = page:match('http://[^.]+%.filefactory.com/dl/f/[^\r\n\'"]+')
		or page:match('http://[^.]+%.filefactory.com/get/f/[^\r\n\'"]+')
	head(dirUrl)
	usd.setretresult(usd.getlocation(), math.random(2,4), 1)
	return
end

function OS(origUrl, dirUrl, fullName)
--	usd.get(origUrl)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, utf8ToAnsi(dirUrl:match('/([^/]+)$')) ))
end


regDirSuccess( 'filefactory.com/file/', GDL, OS)
