--GDL

Storage[script.name] = Storage[script.name] or {}
local st = Storage[script.name]

local conf = tableCombine({
		  skipNonOriginalPics = false
		, photoTemplate = '%author%-%id%-%title%-%width%x%height%'
		, videoTemplate = '%author%-%id%-%title%-%width%x%height%'
}, Settings[script.name] or {})


local apiKey = conf.apiKey or st.apiKey or ''
local logpref

local function getKey()
	usd.setreferer('')
	local p = '%simple%method=flickr.photos.getInfo&param_photo_id='..math.random(8e8, 9e9)..'&enable_photo_id=on&format=rest&param_secret=&sign_call=none'
    local page = usd.post('http://www.flickr.com/services/api/explore/flickr.photos.getInfo', p)
	apiKey = page:match('[&?]api_key=(%x+)') or page:match('"api_key":"(.-)"')
	debugSaveInc(logpref..'_key.html', page, 'key new: '..(apiKey or '<none>') )
	st.apiKey = apiKey
end

local function api(a)
	local fApi = 'https://api.flickr.com/services/rest/?method=flickr.%s&api_key=%s&format=json&nojsoncallback=1'
	local url = fApi:format(a, apiKey) -- old key
	usd.setreferer('')
	local page = usd.get(url)
	if page:find('"message":"Invalid API Key') then
		debugSaveInc(logpref..'_key.html', page..'\r\n', url)
		getKey()
		url = fApi:format(a, apiKey) -- new key
		usd.setreferer('')
		page = usd.get(url)
	end
    local data = parseJsObject(page) or {}
	debugSaveInc(logpref..'.html', page..'\r\n', url..'\r\n\r\n'..serialize(data, nil, true))
	return data
end

local function getPhotos(req)
	local pagenum, idsAll, foundAll, data, photos = 1, {}, 0, nil, nil
	repeat
		data = api(req..'&page='..pagenum)
		if data.stat=='fail' then
			usd.savetolog(data.message)
			usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
			return
		end

		photos = data.photoset or data.photos
		usd.setstatus(foundAll..'/'..photos.total)
		debugLog(#photos.photo..' photos')

		for k,v in ipairs(photos.photo) do
			if idsAll[v.id] then
				debugLog(('dup id: %s title: %s'):format(v.id, utf8ToAnsi(v.title)))
			else
				if not idsAll[v.id] then
					usd.addquery(('http://www.flickr.com/photos/%s/%s#%s'):format(photos.owner or v.owner, v.id, filterName(utf8ToAnsi(v.title),true)))
					idsAll[v.id] = true
					foundAll = foundAll+1
				end
			end
		end
		pagenum = pagenum+1
	until pagenum > photos.pages
	debugLog('Total: '..photos.total..', found: '..foundAll)
	return photos.total == foundAll
end

local function getBig(url)
	if not url:find('%.static.?flickr%.com/%d+/(%d+)') then return end
	local tmp1, tmp2, tmp3 = url:match('^(.-)(%.%w+)$')
	tmp3 = tmp1:match('(_%w)$') or ''
	tmp1 = tmp1:gsub('(_%w)$','')
	if not tmp3:find('_[hko]') then tmp3 = '_b' end
	dirUrl = tmp1..tmp3..tmp2
	dirUrl = dirUrl:gsub('^https:','http:')
	if getLstInfo(true).url == url then usd.modquery(dirUrl) end
	usd.setretresult(dirUrl,1,1)
end




function GDL(origUrl) -- GetDirectLink
	usd.setstatus(script.name)
	logpref = script.name .. '_GDL_v18'
	local dirUrl, page
	script.tmp = {}

	apiKey = conf.apiKey or st.apiKey or ''

	if origUrl:find('//flkr.me/') then
		debugSaveInc(logpref..'.html', usd.get(origUrl))
		origUrl = usd.getlocation()
		usd.modquery(origUrl)
	end

	local short = origUrl:match('//flic.kr/p/(%w+)')	-- http://flic.kr/p/short
		or origUrl:match('/photo.gne?short=(%w+)')
	if short then
		debugSaveInc(logpref..'.html', usd.head('http://www.flickr.com/photo.gne?short='..short))
		origUrl = usd.getlocation()
	end

	local uri = URI.parse(origUrl)
	origUrl = uri()


	local user = uri.path:match('^/photos/([^/]+)')
	local set = uri.path:match('^/photos/[^/]+/sets/(%d+)')
	local group = uri.path:match('^/groups/([^/]+)')
	local photo = uri.path:match('/photos/[^/]+/(%d+)')
			--or origUrl:match('%.static.?flickr%.com/%d+/(%d+)')
			or uri.path:match('/(%d+)_%x+_%w%.%w+$')
			or uri.path:match('/(%d+)_%x+.%w+$')
			or origUrl:match('photo%.gne%?id=(%d+)')


	if photo then
		debugLog('type: photo')
		local data = api('photos.getInfo&photo_id='..photo)

		if data.stat=='fail' then
			usd.savetolog(data.message)
			usd.setretresult(data.code==1 and '%notfound%' or '%'..data.message)
			--return getBig(origUrl)
			return
		end

		local info = {
			  id     = photo
			, author = data.photo.owner.username
			, title  = data.photo.title._content
			, video  = data.photo.video
			, media  = data.photo.media
		}

		if origUrl:find('%.static.?flickr%.com/') or origUrl:find('photo.gne?id=',1,true) then
			origUrl = data.photo.urls.url[1]._content
			usd.modquery(origUrl)
		end

		if info.media == 'photo' then
			local exif = api('photos.getExif&photo_id='..photo)
			if exif.stat=='ok' then
				if not next(exif.photo.exif) then
					usd.waittime(2)
					exif = api('photos.getExif&photo_id='..photo)
				end
				info.camera = exif.photo.camera
				for _, v in ipairs(exif.photo.exif) do
					info[v.tag] = v.raw._content
					info[v.tag..'_clean'] = v.clean and v.clean._content or nil
				end
			end
		end

		data = api('photos.getSizes&photo_id='..photo)
		local pdata

		local maxw=0
		for k, v in ipairs(data.sizes.size) do
			if v.media == info.media
				and not v.source:find('flickr.com/apps/')		-- source = "file.swf", label = "Video Player"
				and (v.width > maxw  or  v.label == "Original")
				then
				if 	not info.video or v.width <= info.video.width
					then
					dirUrl = v.source
					maxw = v.width
					pdata = v
				end
			end
		end

		info.width = pdata.width
		info.height = pdata.height

		debugSaveInc(logpref..'.html', serialize(info, nil, true), nil, false)

		if conf.skipNonOriginalPics and pdata.label~="Original" then
			usd.savetolog('no original')
			return usd.setretresult(unpack(conf.skipNonOriginalPics==2 and {'%notfound%'} or {'%no original', 2}))
		end

		local t = conf[info.media..'Template'] or '%title%'
		script.tmp.newName = type(t)=='function' and t(info) or t:gsub('%%([%w_-]+)%%',info)
		script.tmp.newName = filterName(utf8ToAnsi( script.tmp.newName ) ):gsub('[%s_]+','_'):gsub('_?%-_?','-')
		--debugLog('newName: '..script.tmp.newName)

		if info.video then
			debugSaveInc(logpref..'_video.html', usd.head((dirUrl:gsub('^https:','http:'))), 'video')
			dirUrl = usd.getlocation()
		end
		dirUrl = dirUrl:gsub('^https:','http:')
		usd.setretresult(dirUrl, 0, 1)
		return
	end	-- photo


	if set then
		debugLog('type: set')
		if getPhotos('photosets.getPhotos&photoset_id='..set) then usd.setretresult('%done%') end
		return
	end


	if user then
		debugLog('type: user')
		if not user:find('^%d+@N%d%d$') then  user = api('urls.lookupuser&url='..origUrl).user.id  end
		-- shit! --if getPhotos('people.getPhotos&user_id='..user) then usd.setretresult('%done%') end
		if getPhotos('people.getPublicPhotos&user_id='..user) then usd.setretresult('%done%') end
		return
	end


	if group then
		debugLog('type: group')
		if not group:find('^%d+@N%d%d$') then  group = api('urls.lookupgroup&url='..origUrl).group.id  end
		if getPhotos('groups.pools.getPhotos&group_id='..group) then
			usd.setretresult('%done%')
		else
			usd.setretresult('%notfound%')
		end
		return
	end


	debugLog('not a gallery or picture page')
	usd.setretresult('%notfound%')
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess('.flickr.com/', GDL, OS)
regDirSuccess('//flickr.com/', GDL, OS)
--regDirSuccess('.static.flickr.com/', GDL, OS)
regDirSuccess('.staticflickr.com/', GDL, OS)
regDirSuccess('//flic.kr/', GDL, OS)
regDirSuccess('//flkr.me/url/', GDL, OS)
