
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	--uri = URI.parse(origUrl)
	origUrl=origUrl:match('^([^#]+)')

	script.tmp={}

	local user = origUrl:match('/users/([^/]+)')
	local photo = origUrl:match('/view/(%d+)')
	local album = origUrl:match('/album/(%d+)')
	local uid, data
	local albums = {}
	if album then album=tonumber(album) end

	local function addAlbums(id)
		if albums[id] then
			for k, v in ipairs(albums[id]) do
				usd.addquery(v.links.alternate..'#'..filterName(utf8ToAnsi(v.title),true) )
			end
		end
	end

	if user and not photo then
		page = usd.get('http://api-fotki.yandex.ru/api/users/'..user..'/albums/?format=json')
		data = parseJsObject(page)
		debugSaveInc(logpref..'_albums.html', page, serialize(data or {},nil,true))
		for k, v in ipairs(data.entries) do
			local parent = tonumber((v.links.album or ''):match('/album/(%d+)') or -1)
			albums[parent] = albums[parent] or {}
			table.insert(albums[parent], v)
		end
	end

	if user and not (album or photo) then
		addAlbums(-1)
		usd.setretresult('%done%')
		return
	end

	if album then
		addAlbums(album)
		page = usd.get('http://api-fotki.yandex.ru/api/users/'..user..'/album/'..album..'/photos/?format=json')
		data = parseJsObject(page)
		debugSaveInc(logpref..'_album.html', page, serialize(data or {},nil,true))
		for k, v in ipairs(data.entries) do
			usd.addquery(v.links.alternate..'#'..filterName(utf8ToAnsi(data.title..'-'..v.title),true))
		end
		usd.setretresult('%done%')
		return
	end

	if not (photo and user) then
		--uid, photo = origUrl:match('/get/%d+/(%d+)[^/]*/[^_]+_(%x+)')
		uid, photo = origUrl:match('/get/%d+/(%w+)[^/]*/[^_]+_(%x+)')
		photo = tonumber(photo, 16)
		page = usd.get('http://api-yaru.yandex.ru/person/'..uid..'/')
		debugSaveInc(logpref..'.html', page)
		user = page:match('http://([^.]+)%.ya%.ru" rel="www"')
	end

	local qlist = {'orig','XXXL','XXL','XL','L','M','S','XS','XXS','XXXS'}

	usd.relocationmode(0)
	page = usd.get('http://api-fotki.yandex.ru/api/users/'..user..'/photo/'..photo..'/?format=json')
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))

	local function getDir(url)
		local dir = {url:match('^(http://img%-fotki.yandex.ru/get/%d+/[%d.]+/[%x_]+)(%w+)(%.?%w*)$')}
		if #dir==0 then return end
		for k, v in ipairs(qlist) do
			local tmp = dir[1]..v..dir[3]
			debugSaveInc(logpref..'.html', usd.head(tmp))
			if usd.getheaders():lower():find('http/%d%.%d 200') then
				usd.modquery(tmp)
				usd.setretresult(tmp,0,1)
				return true
			end
		end
	end

	local code = tonumber(usd.getheaders():lower():match('http/%d%.%d (%d+)'))
	if code==403 then
		if getDir(origUrl) then return end
		return usd.setretresult('%notfound%')
	elseif code==404 then
		return usd.setretresult('%notfound%')
	end

	if uid then usd.modquery('http://fotki.yandex.ru/users/'..user..'/view/'..photo..'/') end

	for k, v in ipairs(qlist) do
		if data.img[v] then
			q = v
			dirUrl = data.img[v].href
			break
		end
	end

	local tmp = {}
	table.insert(tmp, data.author)
	if (data.title) then table.insert(tmp, data.title) end
	if (data.summary) then table.insert(tmp, data.summary) end
	table.insert(tmp, data.id:match(':photo:(%d+)'))
	table.insert(tmp, q)
	script.tmp.newName = utf8ToAnsi(table.concat(tmp,'-'))

	debugSaveInc(logpref..'.html', usd.head(dirUrl))
	local ext = '.'..usd.getheaders():match('Content%-Type: %w+/(%w+)'):gsub('^jpeg$','jpg')
	dirUrl = addNewName(dirUrl, script.tmp.newName, nil, nil, ext)

	usd.setretresult(dirUrl, 0, 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, dirUrl:match('/([^/]+)$')))
end

regDirSuccess( 'fotki.yandex.ru/', GDL, OS)
