
function GDL(origUrl, params) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v09'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = tableCombine ({maxGifSize = 128*1024, client_id = '9361333331a86fe'--[[apk]]}, Settings[script.name] or {})
	debugLog(serialize(conf,nil,nil,true))

	params = params or {}
	script.tmp.newName = params.newName or origUrl:match('[&?]/([^&]+)')

	--usd.get('http://0.0.0.0/headers')

	local function api(t,id)
		local url=('https://api.imgur.com/3/%s/%s.json'):format(t,id)
		local page = urlGet(url, {https='Proxomitron', headers={'Authorization: Client-ID '..conf.client_id}})
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data,nil,true))
		if data and data.data and data.data.error then usd.setretresult('%'..data.data.error) end
		return data
	end

	uri = URI.parse(origUrl)


	--local video = uri.path:find('/(%w+)%.gifv$')
	--if video then
	--	local data = api('image',video)
	--end

	local img, ext = uri.path:match('/(%w+)(%.%w+)$')
	if img then
		local base, thumb = img:match('^(.-)([sbtmlh])$')
		local newExt = -1

		if ext=='.gif' or ext=='.gifv' then
			local data = api('image' , base and (#base==5 or #base==7) and base or img)
			--if data.error and base then data = api('image',base) end
			if data.error then return usd.setretresult('%'..(data.error.message=="Image not found" and 'notfound%' or data.error.message)) end
			origUrl = data.data.link
			if data.data.animated and data.data.size > conf.maxGifSize then
				origUrl = data.data.mp4
				newExt = '.mp4'
			end
			if (uri.query) then origUrl = origUrl..'?'..uri.query end
			usd.modquery(origUrl)
		else
			origUrl = 'http://i.imgur.com/'..(base and (#base==5 or #base==7) and base or img)..ext..(uri.query and '?'..uri.query or '')
			debugSaveInc(logpref..'.html', usd.head(origUrl))
			local h = parseHeaders()
            if h.SIZE==503 and h.FILENAME == 'removed.png' then return usd.setretresult('%deleted%') end
		end
		dirUrl = origUrl
		if params.newName then dirUrl =	addNewName(dirUrl, params.newName, nil, nil, newExt) end
		usd.setretresult(dirUrl, 1, 1)
		return
	end


	--local id1, id2 = uri.path:match('^/(%w+)/(%w+)$')
	local id1, id2 = uri.path:match('^/(%w+)/(%w+)')
	if not id1 then
		id2 = uri.path:match('^/(%w+)$')
		if id2 then id1 = 'image' end
	end

	if id1=='gallery' and #id2>=7 then id1='image' end

	if id1=='a' or id1=='gallery' then
		local data = api('album', id2)
		if data.error then
			local err = data.error.message or data.error
			err = err:find(' not found$') and 'notfound%' or err
			data = api('image',id2)
			if not data.error then
				usd.modquery('http://imgur.com/'..id2)
				return usd.setretresult('%Restarting...',5)
			end
			return usd.setretresult('%'..err)
		end
		data = data.data
		debugLog(#data.images..' images')
		local pref = filterName(utf8ToAnsi(data.title~='' and data.title or id2), true)
		local size = 0
		for k, v in ipairs(data.images) do
			size = size + v.size
			local suff = (v.title~='' and v.title) or (v.caption~='' and v.caption) or ''
			suff = filterName(utf8ToAnsi(suff:gsub('<[^>]+>',' ')), true):sub(1,50)
			if suff=='' then suff=nil end
			usd.addquery(addNewName(v.link, pad(k,3), pref, suff, -1))
		end
		debugLog(('%0.2f MB'):format(size/1024/1024))
		usd.setretresult('%done%')
		return
	elseif id1=='image' then
		local data = api('image',id2)
		if data.error then return usd.setretresult('%'..(data.error.message:find(' not found$') and 'notfound%' or data.error.message))	end

		if data.data.title then script.tmp.newName = filterUtf8(data.data.title) end

		dirUrl = data.data.link
		if data.data.type=="image/gif" and data.data.animated and data.data.size > conf.maxGifSize then
			dirUrl = data.data.mp4
		end
		return usd.setretresult(dirUrl, 1, 1)
	end

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, getProperExt(fullName) or -1))
end

regDirSuccess( {'//imgur.com/','.imgur.com/'}, GDL, OS)
