
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v03'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = Settings[script.name] or {
		  interactive = false
		, qualityList = {'full_hd', 'high', 'medium', 'low'}
	}

	local qList = conf.qualityList
	local resume = 0

	--   
	local fmt = string.match(origUrl, '#fmt=([_%w]+)')
	origUrl = origUrl:match('^([^#]+)')

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}

	local external = page:match('<h1 class="b%-topic__title">.-</div>%s*<div class="b%-text">%s*<p>.-</p>')
	external = external and external:match('<iframe src="([^"]+)"')
	if external then
		usd.modquery((external:gsub('&amp;','&')))
		usd.setretresult('%Restarting...',5)
		return
	end

	local title = utf8ToAnsi(
		page:match('<meta content="([^"]+)" property="og:title">')
		or page:match('<meta content=\'([^\']+)\' property="og:title">')
		or page:match('<h1 class="b%-topic__title">(.-)</h1>')
	)
	script.tmp.newName = title
	local urls = {}
	local info = {}
	for u in page:match('data%-url%-list="([^"]+)"'):gmatch('[^,]+') do
		local q = u:match('/([^/]-)_%d+%.%w+$')
		urls[q] = u
		if conf.interactive and not fmt then
			debugSaveInc(logpref..'.html', usd.head(u) )
			local size = usd.getheaders():match('HTTP/%d%.%d 200 OK') and usd.getheaders():match('Content%-Length: (%d+)')
			size = size and string.format('%0.2f', size / 1024 / 1024) or ' ??????'

			table.insert(info
				, string.format(
					'%s MB : %s'
					, pad(size, 7, '  ')
					, q
				)
			)
		end
	end

	if fmt and urls[fmt] then
		resume = 1
		debugSaveInc(logpref..'.html', usd.head(urls[fmt]), origUrl..'\r\n'..fmt)
		usd.setreferer(origUrl)
		dirUrl = urls[fmt]
		usd.setretresult( dirUrl, 0, resume )
		return
	end

	usd.setreferer(origUrl)

	if conf.interactive then
		local dlg = {
			{title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		if usd.progstatus() == 0 then
			debugLog('USD stopped')
			return
		end
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[q]:match(' MB : (.+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		dirUrl = urls[q]
		usd.setretresult( dirUrl, 0, resume )
		return
	end

	for i,v in ipairs(qList) do
		if urls[v] then
			dirUrl = urls[v]
			fmt = v
			break
		end
	end

	usd.modquery(origUrl .. '#fmt='..fmt)
	dirUrl = urls[fmt]
	usd.setretresult( dirUrl, 0, resume )


end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end

regDirSuccess( 'lenta.ru/video/', GDL, OS)
