--GDL

function GDL(origUrl)

--   serializeMirrors()

	usd.setstatus(script.name)

	script.tmp={}

	logpref = script.name .. '_GDL_v04'
	usd.savetolog(logpref)

	local conf = Settings and Settings[script.name]
	if not conf then
		conf = { interactive = false }
	end

	local _ = origUrl:match('<~.-~>')
	if not _ then
		_ = 'no encoded data'
		usd.setretresult('%'.._)
		error(_)
	end

	local data = ascii85.decode(_:gsub('v',"'"):gsub('w','"'))
	data = zlib.decompress(data)
	debugLog(data)	-- {orig = origUrl, mirrors = mirrors}

	_, data = deserialize(data)
	if not _ then
		usd.setretresult('%'..'deserialize() error')
		error(data)
	end

	if data.direct then
		for k, v in ipairs(data.direct) do
			local h = usd.head(v)
			debugSaveInc(logpref..'.html', h)
			local code = tonumber(h:lower():match('^http/%d%.%d (%d+)'))
			if     code == 200 then return usd.setretresult(v,1,1)
			elseif code == 404 then usd.setretresult('%notfound%')
			end
		end
	end

	if data.mirrors then
		local status, _ = getMirror(data.mirrors, {preferred=conf.preferred, interactive=conf.interactive, rows={ {'Name: '..(data.name or 'noname')}, {'Size: '..(data.size or 'nosize')} }} )
		if status then
			script.tmp.mirror = _
			script.tmp.data = data
		end
	end
end

function OS(origUrl, dirUrl, fullName)

	local conf = Settings and Settings[script.name] or {}

	if not (script.tmp and script.tmp.mirror) then return end

	if conf.restoreOriginalUrl and script.tmp.data.orig then
		usd.modquery(script.tmp.data.orig)
		usd.waittime( Settings['<misc>'].modqueryPause )
	end

	--local OShandler, h = getHandler(plg.tOnSuccess, script.tmp.mirror)
	--if OShandler then
	--	if h then debugLog('substring: '..h) end
	--	OShandler(script.tmp.mirror, dirUrl, fullName)
	--	return
	--end
	--debugLog(script.name .. '.lua: PlgOnSuccess handler not found')
end


regDirSuccess( 'ftp://m/', GDL, OS)
