--local openssl

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v10'
	debugLog(logpref)
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	local conf = Settings[script.name] or {packUrls = false}
	debugLog('conf='..serialize(conf,nil,nil,true))

	local sid, master_key

	--local isNode, fileId, fileKey = origUrl:match('^https?://mega%.co%.nz/#(N?)!(.-)!(.+)$')
	--local folderId, folderKey = origUrl:match('^https?://mega%.co%.nz/#F!(.-)!(.+)$')
	--if fileId and #fileKey ~= 43 then return usd.setretresult('%Bad fileKey') end
	--if folderId and #folderKey ~= 22 then return usd.setretresult('%Bad folderKey') end
	local isNode, fileId, fileKey, folderId, folderKey, parentId
	--local linkData = {origUrl:match('/#(%w?)!(.-)!(.+)$')}
	local linkData = split(origUrl:match('/#(.+)'), '!')
	linkData[3] = linkData[3] or prompt('Key for '..origUrl,nil,nil,400)
	if not linkData[3] then return usd.setretresult('%No key') end
	linkData[3] = linkData[3]:gsub('^!','')
	parentId = linkData[4]
	isNode = linkData[1]=='N' and linkData[1]
	if #linkData[3]==43 then
		fileId, fileKey = linkData[2], linkData[3]
	elseif #linkData[3]==22 then
		folderId, folderKey = linkData[2], linkData[3]
	else
		return usd.setretresult('%Bad key (must be 22/43 chars): '..serialize(linkData[3]))
	end
	debugLog(serialize({isNode=isNode, fileId=fileId, fileKey=fileKey, folderId=folderId, folderKey=folderKey, parentId=parentId}))


	usd.get('http://0.0.0.0/headers')

	local errors = {
		 [-1] = 'EINTERNAL (-1): An internal error has occurred. Please submit a bug report, detailing the exact circumstances in which this error occurred.',
		 [-2] = 'EARGS (-2): You have passed invalid arguments to this command.',
		 [-3] = 'EAGAIN (-3): A temporary congestion or server malfunction prevented your request from being processed. No data was altered. Retry. Retries must be spaced with exponential backoff.',
		 [-4] = 'ERATELIMIT (-4): You have exceeded your command weight per time quota. Please wait a few seconds, then try again (this should never happen in sane real-life applications).',
		 [-5] = 'EFAILED (-5): The upload failed. Please restart it from scratch.',
		 [-6] = 'ETOOMANY (-6): Too many concurrent IP addresses are accessing this upload target URL.',
		 [-7] = 'ERANGE (-7): The upload file packet is out of range or not starting and ending on a chunk boundary.',
		 [-8] = 'EEXPIRED (-8): The upload target URL you are trying to access has expired. Please request a fresh one.',
		 [-9] = 'ENOENT (-9): Object (typically, node or user) not found',
		[-10] = 'ECIRCULAR (-10): Circular linkage attempted',
		[-11] = 'EACCESS (-11): Access violation (e.g., trying to write to a read-only share)',
		[-12] = 'EEXIST (-12): Trying to create an object that already exists',
		[-13] = 'EINCOMPLETE (-13): Trying to access an incomplete resource',
		[-14] = 'EKEY (-14): A decryption operation failed (never returned by the API)',
		[-15] = 'ESID (-15): Invalid or expired user session, please relogin',
		[-16] = 'EBLOCKED (-16): User blocked',
		[-17] = 'EOVERQUOTA (-17): Request over quota',
		[-18] = 'ETEMPUNAVAIL (-18): Resource temporarily not available, please try again later'
	}
	local errDeleted = {[-9]=true, [-16]=true}

	local z16 = ('\0'):rep(16)

	local function makeKeyIvMac(key)
		local k = {}
		local l = #key/2
		for i=1, l do
			k[i] = string.char( bit.bxor( key:byte(i), key:byte(i+l) ) )
		end
		local iv = key:sub(17,24) ..('\000'):rep(8)
		local mac = key:sub(-8)
		return table.concat(k), iv, mac
	end

	function hexEncode(str)
		return (str:gsub('.',function(b) return bit.tohex(b:byte(),2)end))
	end
	function hexDecode(str)
		return (str:gsub('%X',''):gsub('..',function(b) return string.char(tonumber(b,16)) end))	-- 0.453
	end

	local aes128cbc = ltn12ce.cipher('aes-128-cbc')

	local function decrypt_key(data, key)
		aes128cbc:setkey(key, 'decrypt')
		aes128cbc:reset(z16)
		return aes128cbc:update(data..z16):sub(1,#data)
	end

	local function decryptNodeKey(key, mkey)	-- ECB!?
		local n = {}
		for i=1, #key, 16 do
			table.insert(n, decrypt_key(key:sub(i,i+15), mkey) )
		end
		return table.concat(n)
	end

	local function b64e(data) return (base64.enc(data):gsub('[/+]',{['/']='_',['+']='-'}):gsub('=+$','')) end

	local function req(data, add, comment)
		local url = 'https://g.api.mega.co.nz/cs?domain=meganz&lang=en&id='..counters[script.name ..'_sequence']..(sid and '&sid='..sid or '')..(add or '')
		--local url = 'https://eu.api.mega.co.nz/cs?id='..counters[script.name ..'_sequence']..(sid and '&sid='..sid or '')..(add or '')
		--local tmp = usd.post(url, data )
		local tmp = urlGet(url, {post=data, gzip=true, https=true} )
		local obj = parseJsObject(tmp)
		local err = obj and obj[1] and errors[obj[1]] or tonumber(tmp) and errors[tonumber(tmp)]
		local c = table.concat{
			comment and comment..'\r\n\r\n' or ''
            , url, '\r\n'
			, data,'\r\n\r\n'
			,serialize(obj or '<nil>',nil,true)
			, err and '\r\n'..err or ''
		}
		debugSaveInc(logpref..'.html', tmp, c )
		return obj or tonumber(tmp)
	end


	if folderKey then
		debugLog('folder')

		folderKey = base64.decode(folderKey)

		local data = req('[{"a":"f","c":"1","r":"1"}]', '&n='..folderId, 'folder' )
		local err = errors[data]
		if err then
			usd.savetolog(err)
			if errDeleted[data] then
				usd.setretresult('%notfound%')
				return
			end
			usd.setretresult('%'..err)
			return
		end

		local folder = data[1]
		local key = base64.decode(folder.f[1].k:match(':(.+)'))
		key = decrypt_key(key, folderKey)
		local attr = base64.decode(folder.f[1].a)
		attr = decrypt_key(attr, key):match('^([^%z]+)')
		attr = parseJsObject(attr)

		local tree = {}
		local function getPath(f)
			local tmp = {}
			local n = tree[f.h]
			for i=1, 11 do
				table.insert(tmp, 1, n.name)
				n = tree[n.p]
				if n.stop or not n then break end
			end
			return table.concat(tmp,'/')
		end

		local names, packedUrls = {}, {}
		for i=1, #folder.f do
		    local f = folder.f[i]
		    tree[f.h]=f
		    if i==1 then tree[f.h].stop=true end
		    local url
			key = decryptNodeKey(base64.decode(f.k:match(':(.+)')), folderKey)
			if f.t == 0 then
				local fileKey = makeKeyIvMac(key)
				attr = parseJsObject(decrypt_key(base64.dec(f.a), fileKey):match('^([^%z]+)'))
				url = 'http://mega.co.nz/#N!'..f.h..'!'..b64e(key)..'!'..folderId
			elseif f.t == 1 then -- wtf?
				--url = 'http://mega.co.nz/#F!'..f.h..'!'..b64e(key)
				url = '<skip>'
				attr = parseJsObject(decrypt_key(base64.dec(f.a), key):match('^([^%z]+)'))
			end
			local name = filterName(utf8ToAnsi(attr.n), true)
			tree[f.h].name=name
			debugLog(url..' '..pad(f.s or '',10,' ')..' '..name)

			if f.s then -- wtf?
				local size = f.s and string.format('%0.2fMB', f.s / 1024 / 1024) or 'F'
				--local n = (tmp[f.h] and tmp[f.h].name..'/' or '')..name
				if conf.packUrls then
					local n = getPath(f)
					local nID = n:lower()..'.'..f.h
					_, url = serializeMirrors({mirrors = {url}, size=size, name=n}, true)
					table.insert(names, nID)
					packedUrls[nID] = url
				else
					usd.addquery(url)
				end
			end
		end

		if conf.packUrls then
			table.sort(names)
			for k, v in ipairs(names) do usd.addquery(packedUrls[v]) end
		end

		usd.setretresult('%done%')
		return
	end

	fileKey = base64.dec(fileKey)
	local key, iv, metamac = makeKeyIvMac(fileKey)
	debugLog('fileKey = '..hexEncode(fileKey))
	debugLog('metamac = '..hexEncode(metamac))
	usd.savetolog(('fix: openssl.exe enc -d -aes-128-ctr -K %s -iv %s -p -in encrypted -out decrypted'):format(hexEncode(key), hexEncode(iv)))

	--local data = req('[{"a":"g","ssl":"0","g":"1","'..(isNode=='N' and 'n' or 'p')..'":"'..fileId..'"}]', nil, origUrl)[1]

	local data = req('[{"a":"g","ssl":"0","g":"1","'..(isNode=='N' and 'n' or 'p')..'":"'..fileId..'"}]'
		, isNode and parentId and '&n='..parentId or nil
		, origUrl)[1]
	local err = errors[data]
	if err then
		usd.savetolog(err)
		if data==-11 and isNode and not parentId then return usd.setretresult('%No parent folder ID. Add folder again.') end
		if errDeleted[data] then return usd.setretresult('%notfound%') end
		return usd.setretresult('%'..err)
	end

	data.at = decrypt_key(base64.dec(data.at), key):match('^([^%z]+)')
	debugSaveInc(logpref..'.html', serialize(data.at,nil,true), nil, false)
	if not data.at:find('^MEGA{.-}$') then
		err = "Error: can not decipher the attributes"
		usd.savetolog(err)
		usd.setretresult('%'..err)
		return
	end
	data.at = parseJsObject(data.at)
	debugSaveInc(logpref..'.html', serialize(data,nil,true), nil, false)

	local newName = utf8ToAnsi(data.at.n)
	local restart, lstInfo = setPusdName(newName)
	if restart then return end

	script.tmp={key=key, iv=iv, metamac=metamac, newName=newName}
	usd.waittime(2, 2)

	dirUrl = data.g		--   

	usd.setretresult(dirUrl, 0, getResumeFlag(lstInfo))
	return
end

--0 / 128K / 384K / 768K / 1280K / 1920K / 2688K / 3584K / 4608K / ... (every 1024 KB) / EOF
--    128    256    384     512     640     768     896    1024


function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	local size = fileSize(fullName)
	local tmpname = fullName..'.d'
	local hw = io.open(tmpname, 'wb')
	if not hw then return usd.savetolog('Error: can not open file: '..tmpname)	end
	local hr = io.open(fullName, 'rb')
	if not hr then return usd.savetolog('Error: can not open file: '..fullName)	end
	local aes128ctr = ltn12ce.cipher('aes-128-ctr')
	aes128ctr:setkey(script.tmp.key, 'decrypt')
	aes128ctr:reset(script.tmp.iv)

	local time = os.clock()

	while true do
	    local buf = hr:read(2^20)	-- 1Mb
	    if not buf then break end
		hw:write( aes128ctr:update( buf ) )
	end
	hw:write( aes128ctr:finish() or '' )
	hw:close()
	hr:close()

	time = math.max(os.clock()-time, 0.001)

	debugLog( ('Decryption time: %0.3f seconds; %0.3f MB/s'):format(time, size/time/1024/1024 ) )

	local _, err = os.remove(fullName)
	if not _ and err then
		usd.savetolog(err)
		return
	end

	return usd.setretresult(fileRename(tmpname, script.tmp.newName))
end

regDirSuccess( '//mega.co.nz/#', GDL, OS)
regDirSuccess( '//mega.nz/#', GDL, OS)
