
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {interactive = false, qualityList = {"1080p","720p","480p","360p","240p"}}

	debugLog(serialize(conf,nil,nil,true))

	local fmt = origUrl:match('#fmt=(%w+)')
	origUrl = origUrl:gsub('#.*$', '')

	usd.setcookie('ero_accept=1')
	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	page = usd.get(page:match('"metaUrl":%s*"([^"]+)"') or page:match('"metadataUrl":%s*"([^"]+)"'))
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	local videoUrls = {}
	for k, v in ipairs(data.videos) do videoUrls[v.key] = v.url end

	local title = utf8ToAnsi(data.meta.title)
	local duration = s2hms(data.meta.duration)
	script.tmp.newName = filterName(title, true)

	if fmt then
		debugSaveInc(logpref..'.html', usd.head(videoUrls[fmt]))
		usd.setretresult(usd.getlocation(), 1, 1)
		return
	end

	if conf.interactive then
		local urls = {}
		local info = {}
		for k, v in ipairs(conf.qualityList) do
			if videoUrls[v] then
				usd.setreferer(origUrl)
				debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
				local h = parseHeaders(usd.getheaders())
				urls[v] = h.LOCATION
				local size = h.SIZE and pad(('%0.2f'):format(h.SIZE / 1024 / 1024), 7, '  ') or ' ??????'
				table.insert(info, ('%s MB - %s'):format(size, v))
			end
		end
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match(' %- (%S+)$')
		fmt = q
		usd.modquery(origUrl .. '#fmt='..fmt)
		usd.setretresult(urls[q], 0, 0)
		return
	end

	for k, v in ipairs(conf.qualityList) do
		if videoUrls[v] then
			debugSaveInc(logpref..'.html', usd.head(videoUrls[v]), v)
			usd.modquery(origUrl .. '#fmt='..v)
			usd.setretresult(usd.getlocation(), 0, 0)
			return
		end
	end


	usd.setretresult(dirUrl, math.random(2,4), 1)
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( {'//my.mail.ru/','.my.mail.ru/'}, GDL, OS)
