--GDL

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v05'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}
	local conf = Settings[script.name] or {qualityList={'1080p','720p','360p'},interactive=false}

	local fmt = origUrl:match('#fmt=(%w+)')
	origUrl = origUrl:match('^([^#]+)'):gsub('/audio/download/','/audio/listen/')

	page = shitFlare(origUrl)
	local ec = page:match('new embedController%(%[{.-</script>')
	ec = ec and ec:gsub('\\u00','%%')
	ec = parseJsObject(ec or '')
	debugSaveInc(logpref..'.html', page, serialize(ec or '<no ec>',nil,true))

--[[
<div class="podcontent">
<p>The file "<em>wrapped_in_pink.swf</em>" (40.5 mb) was uploaded by
<a href="http://surgicalarts.newgrounds.com/">SurgicalArts</a> 1/20/13.</p>
--]]
	if origUrl:find('/dump/item/') then
		local author = page:match('<div class="podcontent">.-was uploaded by <a[^>]+>([^<]+)</a>')
		usd.waittime(2,2)
		dirUrl = origUrl:gsub('/item/','/download/')
		debugSaveInc(logpref..'.html', usd.head(dirUrl))
		script.tmp.newName = author..'-'..parseHeaders().FILENAME
		usd.setretresult(dirUrl,1,1)
		return
	end


	local req = ec and ec[1].portal_item_requirements[1]
	if tableContains(ec and ec[1].portal_item_requirements or {}, 2,3,4) then
		usd.savetolog('Not supported 1')
		usd.setretresult('%notfound%')
		return
	end

	local err = page:match('<div class="podcontent">%s*<p[^>]+>[^<]- (requires a Newgrounds account)')
	if err then
		usd.savetolog(err)
		usd.setretresult('%notfound%')
		return
	end

	local folder = page:match('<div class="fatcol">%s*<div>%s*<div class="podtop">%s*<h2 class="art">(.-)<div class="podbot"></div>.-<div class="fatcol">')
	if folder then
		for u in folder:gmatch('href="([^"]+)"') do usd.addquery(u) end
		return usd.setretresult('%done%')
	end

	local playlist = page:match('<ul class="playlist">.-</ul>')
	if playlist then
		for u in playlist:gmatch('/audio/listen/%d+') do usd.addquery('http://www.newgrounds.com'..u) end
		usd.setretresult('%done%')
		return
	end

	dirUrl = ec and ec[1].url or page:match('src="(http://art.ngfiles.com/images/[^"]+)"')

	if dirUrl:find('/%d+_alternate_%d+.*%.zip$') then
		local tmp = ec[1].callback:match('<iframe src="([^"]+)"')
		tmp = usd.get(tmp)
		debugSaveInc(logpref..'.html', tmp)
		if not tmp:find('value="loader.swf"') then
			usd.savetolog('Not supported 2')
			usd.setretresult('%notfound%')
			return
		end
		dirUrl = dirUrl..'/game.swf'
	    local h = usd.head(dirUrl)
	    debugSaveInc(logpref..'.html', h)
	    if not h:find('HTTP/1.1 200 OK') then
			usd.savetolog('Not supported 3')
			usd.setretresult('%notfound%')
			return
		end
	end

	local title = page:match('<meta property="og:title" content="([^"]+)"')
	local author = page:match('<ul class="authorlinks">.-<em>[^<]+<a href="[^"]+">([^<]+)')
	local id = page:match('"item_id":(%d+)')
	id = id and '-'..pad(id,7) or ''
	local newName = utf8ToAnsi(author..id..'-'..title..dirUrl:match('%.%w+$'))

	local video, vext = dirUrl:match('^(.-)(%.mp4)$')

	if not video then
		newName = filterName(newName, true)
		dirUrl = addNewName(dirUrl, newName)

		usd.setretresult(dirUrl, math.random(2,4), 1)
		return
	end


	if fmt then
		debugSaveInc(logpref..'.html', usd.head(video..'.'..fmt..vext))
		usd.setretresult(addNewName(usd.getlocation(), filterName(newName, true)), math.random(2,4), 1)
		return
	end

	local urls, info = {}, {}

	for k,v in ipairs(conf.qualityList) do
		if ec[1].params.max_resolution >= tonumber(v:match('%d+')) then
			local vurl = video..'.'..v..vext
			usd.setreferer(origUrl)
			debugSaveInc(logpref..'.html', usd.head(vurl) )
			local h = usd.getheaders():lower()
			if not h:match('http/%d%.%d 404 not found') then
				local size = h:match('http/%d%.%d 200 ok') and h:match('content%-length: (%d+)')
				size = size and string.format('%0.2f', size / 1024 / 1024) or ' ??????'
				if size then
					urls[v] = usd.getlocation()
					table.insert(info, ('%s: %s MB'):format(pad(v,5,'  '), pad(size, 7, '  ')) )
				end
			end
		end
	end

	debugSaveInc(logpref..'.html', serialize({urls=urls, info=info},nil,true), nil, false )

	if conf.interactive then
		local duration = tonumber(page:match("'viddur': (%d+)")) or 0
		duration = math.floor(duration / 60)..':'..pad(duration % 60, 2)
		local desc = entityDecode(page:match('<meta name="description" content="([^"]+)"'))
		local dlg = {
			{duration, title}
			, {desc}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		if usd.progstatus() == 0 then
			debugLog('USD stopped')
			return
		end
		local q = dlg:show()
		if q == '' then debugLog('Esc') return end		-- esc
debugLog(q)
		q = q:match('quality=([%d]+)') + 1	--     0
		fmt = info[tonumber(q)]:match('^%s*(%w+)')
		usd.modquery(origUrl .. '#fmt='..fmt)
		usd.setretresult( addNewName(urls[fmt], filterName(newName, true)), 0, 0 )
		return
	end

	for k, fmt in ipairs(conf.qualityList) do
		if urls[fmt] then
			usd.modquery(origUrl .. '#fmt='..fmt)
			usd.setretresult( addNewName(urls[fmt], filterName(newName, true)), 0, 0 )
		end
	end


end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( '.newgrounds.com/', GDL, OS)
