
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {folderWarning = false, packUrls = false}
	debugLog(serialize(conf,nil,nil,true))

	if origUrl:find('//1drv.ms/') then
		usd.relocationmode(0)
		debugSaveInc(logpref..'.html', usd.get(origUrl))
		origUrl = parseHeaders().LOCATION1
		usd.relocationmode(1)
	end

	usd.get('http://0.0.0.0/headers')

	uri = URI.parse(origUrl)
	local query = splitKV(uri.query, '=', '&')

	local tmp = ('https://api.onedrive.com/v1.0/drive/items/%s?authkey=%s'):format(query.resid or query.id, query.authkey or '')
	page = usd.get(tmp)
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, tmp..'\r\n\r\n'..serialize(data,nil,true))

	if data.error then
		local err = (data.error.code=='itemNotFound' or data.error.code=='generalException') and 'notfound%'
			or data.error.code
		return usd.setretresult('%'..err)
	end

	if data["@content.downloadUrl"] then
		script.tmp.newName=filterName(utf8ToAnsi(data.name),true)
		usd.setretresult(data["@content.downloadUrl"]:gsub('^https:','http:')..'/'..script.tmp.newName,1,1)
		return
	end

	if conf.folderWarning then
		local answer = plg.msg(	('Add folder contents?\n\n%s\n\n%d items, %0.2fMB'):format(utf8ToAnsi(data.name), data.folder.childCount, data.size / 1024 / 1024), MB_YESNOCANCEL)
		debugLog('Folder warning answer = '..answer)
		if answer == IDNO then
			return usd.setretresult('%done%')
		elseif answer == IDCANCEL then
			return usd.setretresult('%cancel')
		end
	end

	local tmp = ('https://api.onedrive.com/v1.0/drive/items/%s/children?select=webUrl,name,size,folder&top=1000&authkey=%s'):format(query.resid or query.id,query.authkey or '')
	page = usd.get(tmp)
	local data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, tmp..'\r\n\r\n'..serialize(data,nil,true))

	if data.error then return usd.setretresult('%'..data.error.message) end

	for k,v in ipairs(data.value) do
		local url = v.webUrl
		if conf.packUrls then
			local size = string.format('%0.2fMB%s', v.size / 1024 / 1024, v.folder and '-'..v.folder.childCount or '')
			local name = filterName(utf8ToAnsi(v.name),true)
			_, url = serializeMirrors({mirrors = {url}, size=size, name=name}, true)
		end
		usd.addquery(url)
	end
	usd.setretresult('%done%')
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess( {'drive.live.com/','//1drv.ms/'}, GDL, OS)
