
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v04'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	if origUrl:find('https?://i[mg%d]+%.photobucket%.com/') then
		debugSaveInc(logpref..'.html', usd.head((origUrl:gsub('^https?://i','http://s'))))
		if parseHeaders().CODE==200 then
			origUrl = usd.getlocation()
			usd.modquery(origUrl)
		else
			debugSaveInc(logpref..'.html', usd.head(origUrl))
			if parseHeaders().CODE==404 then return usd.setretresult('%notfound%') end
		end
	end

	local offset = tonumber(origUrl:match('#offset=(%d+)') or 0)
	local limit = 99
	origUrl = origUrl:match('^([^#]+)')

	local function getLinks(base)
		repeat
			setXHR()
			usd.setreferer(origUrl)
			local page = usd.get(base..'&limit='..limit..'&offset='..offset)
			setXHR(true)
			local data = parseJsObject(page)
			debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))
			if offset >= data.body.total then return end
			for k, v in ipairs(data.body.objects) do usd.addquery(v.linkUrl:match('^([^?]+)'))	end
			limit = #data.body.objects
			offset = offset + limit
			usd.modquery(origUrl..'#offset='..offset)
			usd.setstatus(offset..'/'..data.body.total)
		until offset >= data.body.total
	end


	page = usd.get(origUrl)
	origUrl = usd.getlocation()
	local data = page:match('Pb.Data.Shared.put%(Pb.Data.Shared.MEDIA,%s*({.-})%);')
		or page:match('var albumJson = ({.-};)')
	data = parseJsObject(data or '')
	debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))

	local err = page:match('<div class="libraryPrivacyBlockTitle">%s*<h2>[^<]-(Library is Private).</h2>')
		or page:match('<div class="errorPageContainer">%s*<h2>([^<]+)</h2>')
	if err then
		if err =="Sorry, the requested page does not exist." then err = 'notfound%' end
		return usd.setretresult('%'..err)
	end

	local path = data.path

	if path:find('^groups/') then
		getLinks('/component/Album-AlbumThumbnailList?sort=2&json=1&filters[groupAlbum]='..path)
		usd.setretresult('%done%')
		return
	end

	if data.albumPreferenceId then
		setXHR()
		page = usd.get('/component/Albums-SubalbumList?deferCollapsed=true&fetchSubAlbumsOnly=true&json=1&albumPath='..escapeUC(path))
		data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true))
		for k, v in ipairs(data.body.subAlbums) do usd.addquery(v.linkUrl)	end
        setXHR(true)

		getLinks('/component/Common-PageCollection-Album-AlbumPageCollection?json=1&sort=2&filters[album]='..escapeUC(path))

		usd.setretresult('%done%')
		return
	end

	local n = origUrl:match('[?&]/([^&]+)')
	script.tmp.newName = n and n:gsub('~original$','')
		or filterUtf8(table.concat({data.username, data.location, data.title, data.name}, '-'))

	dirUrl = data.originalUrl or data.downloadUrl or data.fullsizeUrl

	usd.setretresult(dirUrl, 1, 1)
	return
end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName))
end


regDirSuccess({'//photobucket.com/','.photobucket.com/'}, GDL, OS)
