
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={}

	local conf = Settings[script.name] or {interactive = false, qualityList = {'720', '480'}}
	debugLog(serialize(conf,nil,nil,true))

	local id = origUrl:match('com/(%d+)')
	local fmt = origUrl:match('#fmt=(%w+)')
	fmt = fmt and tonumber(fmt)
	origUrl = 'http://www.redtube.com/'..id

	page = usd.get(origUrl)
	local data = parseJsObject(page:match("%.createPlayer%([^,]+,%s*({.-)</script>") or '')
	debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))

	local title = utf8ToAnsi(data.medias.videoTitle)
	script.tmp.newName = filterName(title, true)

	if fmt then
		usd.setretresult(data.medias.sources[fmt], 1, 1)
		return
	end

	if conf.interactive then
		local info = {}
		for k, v in ipairs(conf.qualityList) do
			local u = data.medias.sources[v]
			if u then
				usd.setreferer(origUrl)
				debugSaveInc(logpref..'.html', usd.head(u), v)
				local size = parseHeaders(usd.getheaders()).SIZE
				size = pad(size and ('%0.2f'):format(size / 1024 / 1024) or ' ??????', 7, '  ')
				table.insert(info, ('%s: %s MB'):format(pad(v, 5, '  '), size))
			end
		end

		local dlg = {
			{title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match('^%s*(%w+)')
		fmt = tonumber(q)
		usd.modquery(origUrl .. '#fmt='..fmt)
		dirUrl = data.medias.sources[fmt]
		usd.setretresult( dirUrl, 0, 0 )
		return
	end


	for k, v in ipairs(conf.qualityList) do
		dirUrl = data.medias.sources[v]
		if dirUrl then
			usd.modquery(origUrl .. '#fmt='..v)
			usd.setretresult( dirUrl, 0, 0 )
			return
		end
	end

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, -1))
end


regDirSuccess( '.redtube.com/', GDL, OS)
