
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v06'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = Settings[script.name] or { client_id='3904229f42df3999df223f6ebf39a8fe', lossless=false}
	script.tmp={}

	uri = URI.parse(origUrl)

	local function api(req, rdata)
		rdata = rdata or {}
		if not rdata.client_id then rdata.client_id = conf.client_id end
		local url = ('http://api.soundcloud.com/%s.json?%s'):format(req, tableConcat(rdata,'=','&'))
		local page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
		return data
	end

	local function process(data)
		debugLog('data.kind='..tostring(data.kind))
		if data.kind=='user' then
			local id = data.id
			data = api('users/'..id..'/playlists')
			for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
			data = api('users/'..id..'/tracks')
			for k, v in ipairs(data) do usd.addquery(v.permalink_url) end
			usd.setretresult('%done%')

		elseif data.kind=='playlist' then
			for k, v in ipairs(data.tracks) do usd.addquery(v.permalink_url) end
			usd.setretresult('%done%')

		elseif data.kind=='track' then
			script.tmp.newName = filterName(utf8ToAnsi(data.user.username..'-'..data.title), true)
			local f = data.original_format or ''
			-- aiff, wav, flac, m4a, mp3
			dirUrl = (f~="wav" and f~='aiff') and (f~='flac' or conf.lossless) and data.download_url or data.stream_url

            if not dirUrl then
            end

            usd.setreferer(origUrl)

			if dirUrl then
				dirUrl = dirUrl:gsub('^https:','http:')..(dirUrl:find('?',1,true) and '&' or '?')..'client_id='..conf.client_id
				usd.relocationmode(0)
				debugSaveInc(logpref..'.html', usd.get(dirUrl) )
				local h = parseHeaders(usd.getheaders())

				if h.CODE==404 then return usd.setretresult('%notfound%') end

				uri = uri(h.LOCATION1)
			else
            	local page = usd.get('http://api.soundcloud.com/i1/tracks/'..data.id..'/streams?client_id=02gUJC0hH2ct1EGOcYXQIzRFU91c72Ea')
				local data = parseJsObject(page)
				debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
				dirUrl = data.http_mp3_128_url
				uri = uri(dirUrl)
	            usd.setreferer(origUrl)
			end

			local https = tableKeys('soundcloud.hs.llnwd.net')

			if https[uri.host] then
				uri=uri('http://vk.com/away.php?to='..escapeUC(uri()))
				usd.setcookie('remixlang=0')	-- vk
				getResumeFlag(nil, true)
			else
				uri.scheme='http'
			end
			--dirUrl = addNewName(uri(), script.tmp.newName) -- cf-media.sndcdn.com
			dirUrl = uri()
			usd.setreferer(origUrl)
			usd.setretresult(dirUrl, 0, 1)

		else
			usd.setretresult('%unknown type')
		end
	end -- process

--https://w.soundcloud.com/player/?url=http%3A%2F%2Fapi.soundcloud.com%2Ftracks%2F123&visual=true&liking=false&sharing=false&auto_play=false&show_comments=false&continuous_play=false&origin=tumblr
	if uri.host=='w.soundcloud.com' then
		origUrl = unescape(uri.query:match('url=(http[^&]+)'))
		uri = URI.parse(origUrl)
	end


	local data

	local secret_token = origUrl:match('[&?]secret_token=([^&]+)')

--http://api.soundcloud.com/tracks/123/stream
	if uri.host=='api.soundcloud.com' then
		--data = api(uri.path:match('^/([^/]+/[^/]+)'))
		data = api(uri.path:match('^/([^/]+/[^/.]+)'), {secret_token=secret_token})
		origUrl = data.permalink_url
	else
		data = api('resolve', {url=origUrl})
	end

	if ((data.errors or {})[1] or {}).error_message == "404 - Not Found" then return usd.setretresult('%notfound%') end

	if data.permalink_url then usd.modquery(data.permalink_url) end

	if data.kind then
		process(data)
	else
		for k, v in ipairs(data) do process(v) end
	end


end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	local ext = URI.parse(dirUrl).path:match('%.%w+$')
	return usd.setretresult(fileRename(fullName, script.tmp.newName, ext))
end


regDirSuccess( '//soundcloud.com/', GDL, OS)
regDirSuccess( '.soundcloud.com/', GDL, OS)
regDirSuccess( '//snd.sc/', GDL, OS)
