-- GDL

local version = 13
local logpref

local conf = tableCombine({
	apiKey='fuiKNFp9vQFvjLNvx4sUwti4Yb5yGutBN4Xh10LXZhhRKjWlV4'	-- Tumbo
	, playKey = 'e6ba8f023e92bbb5aaf06052cd0c6551'
}, Settings[script.name] or {})

conf.mirrors = conf.mirrors or {'.tumblr.com/', '//tmblr.co/'}
conf.types = conf.types or {'video', 'audio', 'photo', 'text', 'answer', 'link'}
conf.skip = conf.skip or {}

Storage[script.name] = Storage[script.name] or {}
local st = Storage[script.name]

local uri

local function api(blog, method, req, search)
	local page = usd.get(('http://api.tumblr.com/v2/blog/%s/%s?%s&api_key=%s'):format(blog, method, tableConcat(req,'=','&'), conf.apiKey)..(search and '&tag='..search or ''))
	if page=='' and parseHeaders().CODE==200 then
		usd.setretresult('%notfound%')
		return {}
	end
    local data = parseJsObject(page) or {}
	debugSaveInc(logpref..'.html', page..'\r\n', serialize(data, nil, true))
	return data
end

local function apiTagged(tag, host, offset)
	offset = offset or 0
	local page
	if host=='tumblr.com' then
		--page = usd.get(('http://api.tumblr.com/v2/tagged/?tag=%s&limit=20&filter=text&timestamp=%s&api_key=%s'):format(tag, offset and offset>0 and offset or '', conf.apiKey))
		local err = 'not supported'
		debugLog(err)
		usd.setretresult('%'..err)
		return {meta={status=404}}
	else
		page = usd.get(('http://api.tumblr.com/v2/blog/%s/posts?tag=%s&offset=%s&api_key=%s'):format(host, tag, offset, conf.apiKey))
	end
    local data = parseJsObject(page) or {}
	debugSaveInc(logpref..'.html', page..'\r\n', 'apiTagged'..'\r\n\r\n'..serialize(data, nil, true))
	return data
end


local function makeUrl(u) u=URI.recode(u) return getHandler(plg.tDirLink, u) and u or (u:gsub('^[^/]+//','ftp://direct/')) end

local function isDirect(u) if u:find('media%.tumblr%.com/') then return true end end

local function checkSkipUrl(url)
	if conf.skip and #conf.skip>0 then
		for k, v in ipairs(conf.skip) do
			if url:find(v) then
				debugLog('checkSkipUrl(): '..(url))
				usd.setretresult('%notfound%')
				return false
			end
		end
	end
	return true
end

local tmpUrlsCaption = {}	--  post.caption

local function checkUrl(url, tmpUrls)
	if not url then return false end
	url = url:gsub('^https:','http:')
	local id = url:match('media.tumblr.com/(%x+)/')
		or url:match('media.tumblr.com/tumblr_(%w+)')
	id = #(id or '')==32 and id
	if tmpUrls[url] or (id and tmpUrls[id]) then
		debugLog('checkUrl() dup: '..(url or id))
		return false
	end	-- dup
	for k, v in ipairs({'media.tumblr.com/avatar_', '//assets.tumblr.com/'}) do
		if url:find(v,1,true) then return false end
	end
	if not checkSkipUrl(url) then return false end
	tmpUrls[url] = true
	if id then tmpUrls[id] = true end
	return true
end


local function isTumblr(url)
	url = URI.recode(url)	-- "http://blog.tumblr.com" -> "http://blog.tumblr.com/"
	if url:find('^[^/]+//[^/]+/$') then return true end	-- path=='/', no query, no fragment
	for k, v in ipairs(conf.mirrors) do
		if url:find(v,1,true) then return true end
	end
	return false
end

local function get(url, str, origUrl, newName)
	debugLog('get ('..tostring(str)..'): '..tostring(url))
	if not url then return false end
	url = url:gsub('^https:','http:')

	if url:find('^https?://tmblr%.co/') then
		debugSaveInc(logpref..'.html', urlHead(url))
		url = usd.getlocation()
	end

	local uri = URI.parse(url)

	--local handler = getHandler(plg.tDirLink, url)
	if url:find('^ftp://m/') or url:find('^ftp://directs?/') then
		getHandler(plg.tDirLink, url)(url)
		return true
	end


	local host = getHost(uri)
	if not host then
		usd.savetolog('Bad url')
		return false
	end

	if isTumblr(url)
		and (
			not (host:find('media%.tumblr%.com$') or (uri.path or ''):find('^/post/'))
			or uri.path=='/'
		)
		then
		debugLog('stop - tumblr')
		local err = '%notfound%'	--     
		usd.setretresult(err)
		return false, err
	end

	local status, err = getMirror({url}, {params={newName=newName}, skipUrl=true})
	if status then
		if --not host:find('media%.tumblr%.com$')
			--and not url:find('tumblr.com/audio_file/')
			--and host~='a.tumblr.com'
			not getHost(uri,nil,nil,2)=='tumblr.com'
			and host~='direct'
			and getLstInfo().url == origUrl
			then usd.modquery(url)
		end
		return true
	elseif err=='%notfound%' then	-- ? '%getMirror error'
		return false, err
	end

	if getHost(uri)=='youtube.com' or getHost(uri)=='youtu.be' then
		debugLog('skip HEAD check')
		usd.setretresult('%error', 10)
		return false
	end
	debugSaveInc(logpref..'.html', usd.head(url), 'get() HEAD check')
	local h = parseHeaders()
	local t = (h.TYPE or ''):match('^([^/]+)')
	if h.CODE==404 then
		usd.setretresult('%notfound%')
		return false --   ,     
	elseif h.CODE==200 and t~='text' and (h.SIZE or 0)>44 and not h.LOCATION:find('/pixel.gif$') and not h.LOCATION:find('directupload_not_found') then
		debugLog('get(): direct?')
		local dir = convertGif(url, conf.maxGifSize) or url
		dir = addNewName(dir, newName)
		debugLog('dir='..dir)
		usd.setretresult(dir,1,1)
		return true
	end

	debugLog('get(): end')
	return false
end

local function checkGet(url, str, origUrl, tmpUrls, newName)
	local r = checkUrl(url, tmpUrls) and get(url, str, origUrl, newName)
	debugLog('checkGet(): '..tostring(r))
	return r
end


local CNDphotos = {}

local function checkNewDupes(post)	-- true if not dup
	if not conf.filterDupes then return true end
	local dupes = 0
	if post.type=='photo' then
		for k, v in ipairs(post.photos) do
			local id = v.alt_sizes[1].url:match('media.tumblr.com/(%x+)/')
				or v.alt_sizes[1].url:match('media.tumblr.com/tumblr_(%w+)')
			if not id then
				debugLog('checkNewDupes(): no photo id: '..post.id)
			else
				if CNDphotos[id] then
					debugLog('checkNewDupes(): '..id)
					dupes = dupes+1
				end
				CNDphotos[id] = true
			end
		end
		return dupes ~= #post.photos
	end
	return true
end

----------------------------------------------------------------------------------------------------------------------------------------

function GDL(origUrl, params) 	-- GetDirectLink
	params = params or {}
	logpref = script.name .. '_GDL_v'..pad(version, 2)
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form
	script.tmp={}

	local tmpUrls = {}

	uri = URI.parse(origUrl)

	local offset = tonumber((uri.fragment or ''):match('offset=(%d+)') or 0)
	local search = uri.path:match('^/search/([^/]+)')
	-- encoded local tagged = uri.path:match('^/tagged/([^/]+)')
	local tagged = origUrl:match('^[^/]+//[^/]+/tagged/([^/]+)')
	--local search = uri.path:match('^/search/([^/]+)') or uri.path:match('^/tagged/([^/]+)')

	if uri.host=='tmblr.co' or (uri.host=='www.tumblr.com' and not (search or tagged)) then
	    local name, post = uri.path:match('^/video/(%w+)/(%d+)')
		if name then origUrl = 'http://'..name..'.tumblr.com/post/'..post end
		debugSaveInc(logpref..'.html', urlHead(origUrl, ''), "uri.host=='tmblr.co' or uri.host=='www.tumblr.com'")
		origUrl = usd.getlocation()
		uri = URI.parse(origUrl)
	end

--text, quote, link, answer, chat, video, audio, photo
	local supported = tableKeys(unpack(conf.types))


--http://blog.tumblr.com/

	if tagged then
		debugLog('tagged start')
		if not tagged:find('%%') then tagged = escapeUC(plg.recode(CP_ACP, CP_UTF8, tagged)) end
		tagged = tagged:gsub('%-',' ')
		--local offset = 0
		local data
		local host = getHost(uri)
		repeat
			data = apiTagged(tagged, host,
				host=='tumblr.com' and
					(data and data.response
					and #data.response>0
					and (data.response[#data.response].featured_timestamp or data.response[#data.response].timestamp)
					--or nil
					)
				or offset)
			if data.meta.status~=200 then break end
			local tmp = data.response.posts or data.response
			debugLog('#tmp='..#tmp)
			usd.setstatus(offset..' / '..(data.response.total_posts or -1))
			for _, v in ipairs(tmp) do
				if supported[v.type] then
					if checkNewDupes(v) then
						usd.addquery(URI.recode(v.post_url))
					end
				end
			end
			offset = offset+#tmp
--usd.modquery(uri('#offset='..offset)(nil,true))
		until offset>=data.response.total_posts
			or data.meta.status~=200
			or #tmp==0
		debugLog('tagged end')
		usd.setretresult(data.meta.status==200 and '%done%' or data.meta.status==404 and '%notfound%' or '%'..data.meta.msg )
		return
	end

	if uri.path == '/' or search then
		debugLog('search start')
		--local offset = 0
		local resume = offset>0
		local skippedDupes = 0
		local skippedOld = false
		--local data = {response={total_posts=math.huge}}
		search = search and unescape(search:gsub('%-',' '))
		repeat
			--local data = api(uri.host, 'posts', {offset=offset, filter='text'}, search)
			local data = api(uri.host, 'posts', {offset=offset, filter='text'}, search)
			if data.meta.status==404 then return usd.setretresult('%notfound%') end
			if data.response.blog.total_posts==0 then
				debugLog('checking new tumblr...')
				page = usd.get(origUrl)
				debugSaveInc(logpref..'.html', page)
				local new = page:match('<div class="text">%s*<div>New tumblr now at</div>.-<div class="text">%s*<div><a href="([^"]+)"><big>')
				if new then
					new = URI.combine(new, uri.path)()
					usd.modquery(new)
					usd.setretresult('%restarting...',5)
					return
				end
			end
			local greater = st[data.response.blog.name]
			if conf.rememberGreaterID and greater and offset == 0 and uri.path == '/' then debugLog('Greater ID: '..greater) end
			usd.setstatus(offset..' / '..data.response.total_posts)
			for _, v in ipairs(data.response.posts) do
				if not resume and conf.rememberGreaterID and greater and uri.path == '/' then
					if v.id <= greater then
						skippedOld = true
						debugLog('Old posts was skipped')
						offset = math.huge
						break
					end
				end
				if supported[v.type] then
					local url = URI.recode(v.post_url)
					if checkNewDupes(v) and checkSkipUrl(url) then
						usd.addquery(url)
						--debugLog('added: '..url)
					else
						--debugLog('skipped: '..url)
						skippedDupes = skippedDupes+1
					end
				end
			end
			offset = offset + #data.response.posts
usd.modquery(uri('#offset='..offset)(nil,true))
		until ( data.response.total_posts <= offset )
		if conf.filterDupes then debugLog('skippedDupes: '..skippedDupes) end
		debugLog('search end')
		usd.setretresult(skippedOld and '%notfound%' or '%done%')
		return
	end

	if uri.host:find('media.tumblr.com$') or uri.host=='a.tumblr.com' then	-- direct
		local tmpq = (uri.query or ''):match('^/([^&]+)')
		script.tmp.newName = params.newName or (tmpq and unescape(tmpq))
		if not (uri.query or ''):find('^/%w') then
			debugSaveInc(logpref..'.html', usd.head(origUrl))
			local h = parseHeaders()
			if h.CODE ~= 200 then return usd.setretresult('%'..h.REASON) end
		end
		uri.query = nil
		dirUrl = uri()
		dirUrl = convertGif(dirUrl, conf.maxGifSize) or dirUrl
		if dirUrl:find('/tumblr_inline_[^_]+_%d+%.') then
			local tmp = dirUrl:gsub('(/tumblr_inline_[^_]+_)(%d+)%.','%11280.')
			debugSaveInc(logpref..'.html', usd.head(tmp))
			if parseHeaders().CODE==200 then
				usd.modquery(URI.combine(tmp,'?'..(tmpq and '/'..tmpq or ''))())
				dirUrl = tmp
			end
		end
		return usd.setretresult(dirUrl,1,1)
	end

	if uri.host=='www.tumblr.com' and not uri.path:find('^/video/') then
		local n = uri.fragment and uri.fragment:match('#newName=(.+)')
		debugSaveInc(logpref..'.html', usd.head(uri()), "uri.host=='www.tumblr.com'")
		dirUrl = (usd.getlocation():gsub('#.*$',''))
		script.tmp.newName = n or script.tmp.newName
		usd.setretresult(dirUrl,1,1)
		return
	end

--http://blog.tumblr.com/post/1234
	local id = uri.path:match('^/post/(%d+)')
		or uri.path:match('^/image/(%d+)')
		or uri.path:match('^/reblog/(%d+)')
	id = tonumber(id)

	if id then
		debugLog('id start')
		local data = api(uri.host, 'posts', {id=id})
		if not next(data) then return end -- notfound
		if data.meta.status~=200 then
			if data.meta.status==404 then
				page = usd.get(origUrl)
				debugSaveInc(logpref..'.html', page)
	-- http://zephyrxz.tumblr.com/post/134281511186
				local sendto = page:match("function sendto%(%) {%s*window.location.replace%('https?(://[^']+)' %+ window.location.pathname")
				if not sendto then return usd.setretresult('%notfound%') end
				origUrl = 'http' .. sendto .. uri.path
				uri = URI.parse(origUrl)
				data = api(uri.host, 'posts', {id=id})
				if data.meta.status==404 then return usd.setretresult('%notfound%') end
			else
				return usd.setretresult('%'..data.meta.msg)
			end
		end

		local post = data.response.posts[1]

		if not supported[post.type] then
			debugLog('id end - wrong type: '..post.type)
			usd.setretresult('%notfound%')
			return
		end

		debugLog('type: '..post.type)

		if conf.rememberGreaterID and id > (st[data.response.blog.name] or 0) then st[data.response.blog.name] = id end

--'link': post.url ?

		local addSlug = not (
			(type(conf.noSlugs)=='table' and tableContains(conf.noSlugs, data.response.blog.name))
			or conf.noSlugs==true
			or post.slug==''
		)

		local newName = {data.response.blog.name, pad(post.id,12)}
		if addSlug then table.insert(newName,post.slug) end
		newName = filterName(utf8ToAnsi(table.concat(newName, '-')), true)
		script.tmp.newName = newName

		local stopAfter = tableKeys('youtube.com','youtu.be')

		--if get(post.permalink_url,'permalink_url',origUrl) or get(post.link_url,'link_url',origUrl) then return end
		if post.permalink_url ~= origUrl and post.link_url ~= origUrl then
			if checkGet(post.permalink_url,'permalink_url',origUrl, tmpUrls, newName)
				or checkGet(post.link_url,'link_url',origUrl,tmpUrls, newName)
				or (post.permalink_url and stopAfter[getHost(post.permalink_url)] )
				then return end
		end

		debugLog('type handler start:')

------------------------------------------------------------------------------------------------------------------------------------------------------
		if post.type == 'photo' then
			local photos = {}

			for k, v in ipairs(post.photos) do
				if	v.original_size.height>15 and v.original_size.width>15
					and checkUrl(v.original_size.url, tmpUrls)
					then
					table.insert(photos, v)
				end
			end

			for u in post.caption:gmatch('<img[^>]- src=[\'"](https?://[^\'"]+)[^>]->') do
				u = entityDecode(u)
				local c2
				if conf.filterDupes then c2 = checkUrl(u, tmpUrlsCaption) else c2 = true end
				if checkUrl(u, tmpUrls) and c2 then table.insert(photos, makeUrl(u)) end
			end

			local function biggest(t)
				if type(t)=='string' then return t end
				local p, o = t.panorama_size, t.original_size
				if p and (p.width > o.width) then return p.url end
				local ouWidth = tonumber(o.url:match('_(%d+)s?q?%.%w+$') or '') or 99999
				--if ouWidth < o.width then
				if ouWidth < 1280 then
					local tmp = o.url:gsub('_[%dsq]+(%.%w+)$','_1280%1')
					debugSaveInc(logpref..'.html', usd.head(tmp), 'check original fix')
					if parseHeaders().CODE==200 then return tmp end
				end
				return o.url
			end

			if #photos==1 then

				--post.source_url -    

				usd.setreferer('')
				--dirUrl = photos[1].original_size.url
				dirUrl = biggest(photos[1])
				if not isDirect(dirUrl) then return getMirror({photos[1]}, {params={newName=newName},skipUrl=true}) end
				dirUrl = convertGif(dirUrl:gsub('%?.*$',''), conf.maxGifSize) or dirUrl
				if dirUrl:find('^http://www.tumblr.com/') then
					debugSaveInc(logpref..'.html', usd.head(dirUrl), '#photos==1')
					dirUrl = (usd.getlocation():gsub('#.*$',''))
				end
				--dirUrl = addNewName(dirUrl, newName, nil, nil, -1) -- 66.media.tumblr.com
				debugLog(script.tmp.newName)
				usd.setretresult(dirUrl, 0, 1)
				usd.modquery(origUrl)
				debugLog('id end - 1 '..post.type)
				return
			else
				local l = math.max(#tostring(#photos), 2)
				for k, v in ipairs(photos) do
					local n = {data.response.blog.name, pad(post.id,12), pad(k,l)}
					if type(v)=='table' and v.caption and v.caption~='' then
						table.insert(n, utf8ToAnsi(v.caption))
					elseif addSlug then
						table.insert(n, utf8ToAnsi(post.slug))
					end
					n = filterName(table.concat(n, '-'), true)
					local dir = biggest(v)
					if dir:find('^http://www.tumblr.com/') then
						dir = dir..'#newName='..n
					else
						dir = addNewName(dir, n, nil, nil, -1)
					end
					usd.addquery(dir)
				end
				debugLog('id end - '..post.type)
				usd.setretresult('%done%')
				return
			end

------------------------------------------------------------------------------------------------------------------------------------------------------
		elseif post.type == 'video' then
			if not post.video_url then
				local url
				if post.player[#post.player].embed_code then
					url = post.player[#post.player].embed_code:match('<iframe[^>]-src=[\'"]([^\'"]+)')
						or post.player[#post.player].embed_code:match('<embed[^>]-src=[\'"]([^\'"]+)')
						or post.player[#post.player].embed_code:match('<a[^>]-href=[\'"]([^\'"]+)')
				end
				if url then return checkGet(URI.recode(url),'video iframe',origUrl,tmpUrls, newName) end
				return usd.setretresult('%notfound%')
			end

			local fmt = origUrl:match('#fmt=(%w+)')		fmt = tonumber(fmt) or fmt
			origUrl = origUrl:gsub('#.*$','')

			if post.video_url:find('//vt.tumblr.com/') then
				local qData = {}
				local info = {}
				local vmax = post.video_url:gsub('%_%d+.mp4$','.mp4')
				local ql = tableCopy(conf.qualityList or {})
				if not tableContains(ql,post.thumbnail_height) then table.insert(ql,post.thumbnail_height) end
	            for _, v in ipairs(ql) do
	            	if v<=post.thumbnail_height then
		            	local tmp = v==post.thumbnail_height and vmax or vmax:gsub('%.mp4$','_'..v..'.mp4')
						debugSaveInc(logpref..'.html', usd.head(tmp), v)
						local h = parseHeaders()
						local size = h.CODE==200 and h.SIZE
						if size then
							size = string.format('%0.2f', size / 1024 / 1024) or ' ??????'
							table.insert(info, ('%s: %s MB'):format(pad(v,4,'  '), pad(size, 7, '  ')))
							qData[v] = usd.getlocation()
						end
					end
				end
				if fmt then return usd.setretresult(qData[fmt],0,1) end
				if not next(qData) then
					debugLog('dead video?')
					usd.setretresult('%notfound%')
					return
				end
				if conf.interactive then
					local duration = s2hms(post.duration)
					local title = post.summary~='' and utf8ToAnsi(post.summary) or script.tmp.newName

					local dlg = {
						{duration}
						, {title}
						, {'__________________________'}
						, {'Select quality:'}
						, {{type='select', name='quality', info }}
					}
					local dlg = Dialog.new(dlg, script.name)
					local q = dlg:show()
					if q == '' then return end		-- esc
					q = q:match('quality=([%d]+)') + 1	--     0
					q = info[tonumber(q)]:match('^%s*(%w+):')
					fmt = tonumber(q) or q
					usd.modquery(origUrl .. '#fmt='..fmt)
					dirUrl = qData[fmt]
					--dirUrl = addNewName(dirUrl, newName)
					usd.setretresult( dirUrl, 0, 0 )
					debugLog('id end - '..post.type..' - interactive')
					return
				end

				for k, q in ipairs(ql) do	if qData[q] then	fmt = q	break	end	    end
				usd.modquery(origUrl .. '#fmt='..fmt)
				--usd.setretresult(addNewName(qData[fmt], newName), 0, 0 )
				usd.setretresult(qData[fmt], 0, 0 )
				debugLog('id end - '..post.type..' - auto')
				return
			end

			if not checkUrl(post.video_url, tmpUrls) then return usd.setretresult('%done%') end
			local ok, err = get(post.source_url, 'post.source_url', origUrl, newName)
			if not ok then
				debugLog('tryin post.video_url')
				--dirUrl = addNewName(post.video_url, newName)
				dirUrl = post.video_url
				usd.setretresult(dirUrl,1,1)
			end
			debugLog('id end - '..post.type)
			return

------------------------------------------------------------------------------------------------------------------------------------------------------
		elseif post.type == 'audio' then
			if post.audio_type == "spotify" or post.audio_url:find('%.spotify%.com/') then return usd.setretresult('%notfound%') end
			if post.audio_type=="tumblr" then
				dirUrl = post.audio_url:gsub('^https:','http:')..(getHost(post.audio_url,nil,nil,2)=='tumblr.com' and '?play_key='..conf.playKey or '')
				debugSaveInc(logpref..'.html', usd.head(dirUrl), 'audio')
				dirUrl = usd.getlocation():gsub('^https:','http:'):gsub('#.*$','')
				--dirUrl = addNewName(dirUrl, newName, nil, nil, -1)
				usd.modquery(origUrl)
				usd.setretresult(dirUrl,1,1)
				return
			else
				if checkGet(post.source_url,'source_url',origUrl,tmpUrls,newName) or checkGet(post.audio_url,'audio_url',origUrl,tmpUrls,newName)
					then return debugLog('id end - '..post.type) end
			end
			if plg.getretresult():find('^%%') then return end
			usd.setretresult('%plugindefect '..post.type)
			return

------------------------------------------------------------------------------------------------------------------------------------------------------
		elseif post.type == 'text'  or  post.type == 'answer' then
			local urls = {}
			local body = post.body or post.answer or nil
			local function grab(u)
				u = entityDecode(u)
				--if checkUrl(u, tmpUrls) and not isTumblr(u) then
				if checkUrl(u, tmpUrls) then
					table.insert(urls, makeUrl(u))
				end
				return ''
			end
			body = body:gsub('<iframe[^>]- src=[\'"](https?://[^\'"]+).-</iframe>', grab)
			body = body:gsub('<a[^>]- href=[\'"](https?://[^\'"]+).-</a>', grab)
			body = body:gsub('<img[^>]- src=[\'"](https?://[^\'"]+)[^>]->', grab)
			local l = math.max(2,#tostring(#urls))
			for k,v in ipairs(urls) do
				--if type(v)=='table' then
					local pref, name
					pref = {post.blog_name, pad(post.id,12)}
					if #urls>1 then table.insert(pref, pad(k, l)) end
					if addSlug then table.insert(pref, post.slug) end
					pref = filterUtf8(table.concat(pref,'-'), true)
					--if v[1]:find('media%.tumblr%.com/') then pref, name = name, pref end
					if v:find('media%.tumblr%.com/') then pref, name = name, pref end
					--urls[k] = addNewName(v[1], name, pref, nil, -1)
					urls[k] = addNewName(v, name, pref, nil, -1)
				--end
			end
			if #urls==1 then
				local tmp, n = urls[1]:match('^([^?]+).-[?&]/([^&]+)$')
				if tmp:find('media%.tumblr%.com/') then
					newName = n
					urls[1] = tmp
				end
				return get(urls[1], 'text single url', origUrl, newName)
			end
			for k, v in ipairs(urls) do usd.addquery(v) end
			usd.setretresult('%done%')
			return

------------------------------------------------------------------------------------------------------------------------------------------------------
		elseif post.type == 'link' then

			if uri.host == URI.parse(post.url).host then
				debugLog('skipping link to this blog: '..post.url)
				usd.setretresult('%done%')
				return
			end

			if not checkUrl(post.url, tmpUrls) then return usd.setretresult('%done%') end

			local ok, err = get(post.url, 'post.url',origUrl, newName)
			if ok then return debugLog('id end - '..post.type) end
			if err == '%notfound%' then return end
			usd.setretresult('%unknown '..post.url, 5)
			return
		end

		debugLog('id end - unknown type ?')
	end -- if id

	usd.setretresult('%no id')

end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, getProperExt(fullName) or -1))
end

--function OE(dirUrl, errMsg, data)
---- 564 - not found
---- 162 - temp. not found?
---- 243,  231
----plg.msg('on error')
--	if data=='InvalidCust' or #data==162 then usd.setretresult(1) end
--	if errMsg=='Forbidden' then usd.setretresult(0) end
--end
--
--function OC(dirUrl, fullName, headers, currStatus)
--	if currStatus==0 and headers:find('X%-HW: %d+') then usd.setretresult(1) end
--end

function SU(url)
	local uri = URI.parse(url)
	if (uri.path or '/')=='/'
		or uri.path=='/mobile'
		or uri.path:find('^/tagged/')
		or uri.path:find('^/blog/')
		then
		return true
	end
end

regDirSuccess( conf.mirrors, GDL, OS, SU )
--regCheckError( 'media.tumblr.com/', OC, OE)
