--GDL

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri
	script.tmp={parts={},files={}}
	local sizes, parts, files = {}, script.tmp.parts, script.tmp.files

	local conf = Settings[script.name] or { qualityList = {"chunked","high","medium","low","mobile"} }
	debugLog(serialize(conf,nil,nil,true))

	uri = URI.parse(origUrl)

	local id1, id2 = uri.path:match('/[^/]+/(%w+)/(%d+)')
	local id = id1..id2

	local function api(url)
		usd.setreferer(origUrl)
		local page = usd.get(url)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
		return data, page
	end

	local dInfo = api('http://api.twitch.tv/kraken/videos/'..id..'?on_site=1')
	local dToken = api('http://api.twitch.tv/api/vods/'..id2..'/access_token?as3=t')
	page = usd.get(('http://usher.justin.tv/vod/%s?allow_source=true&nauth=%s&player=twitchweb&nauthsig=%s'):format(id2,escapeUC(dToken.token),dToken.sig))
	local PLs = {}
	for q, l in page:gmatch('VIDEO="(%w+)".-(https?://[^\r\n]+)') do PLs[q]=l end
	debugSaveInc(logpref..'.html', page, serialize(PLs,nil,true))

	script.tmp.newName = filterName(utf8ToAnsi(dInfo.title), true)

	local quality
	for k, v in ipairs(conf.qualityList) do
		if PLs[v] then
			quality = v
			break
		end
	end
	if not quality then
		quality = next(PLs)
		debugLog('No suitable quality')
	end
	debugLog('quality: '..quality)

	local playlist = PLs[quality]
	uri = URI.parse(playlist)
	usd.setreferer(origUrl)
	page = usd.get(playlist)
		local tmp = {}
		for f, s, e, t in page:gmatch('[\r\n]([%w.-]+.-[?&])start_offset=(%d+)&end_offset=(%d+)([^%s]*)') do table.insert(tmp,{f,tonumber(s),tonumber(e),t}) end
		for i=#tmp, 2, -1 do
			if tmp[i-1][1]==tmp[i][1] and tmp[i-1][3]+1==tmp[i][2] then
				tmp[i-1][3] = tmp[i][3]
				table.remove(tmp,i)
			end
		end
		local tempDir = Settings['<misc>'].tempDir or getLstInfo().saveto
		for k, v in ipairs(tmp) do
			table.insert(parts, uri(('%sstart_offset=%s&end_offset=%s%s'):format(unpack(v)))())
			table.insert(files, ('%s%s_%s_%s.ts'):format(tempDir,script.name,id,pad(k,3)))
			table.insert(sizes, v[3]-v[2]+1)
		end
		debugSaveInc(logpref..'.html', page, serialize(parts,nil,true),nil,false)


	for i=1, #parts do
		local msg = 'downloading part '..i..'/'..#parts
		debugLog(msg)
		usd.setstatus(msg)
		local fsize = fileSize(files[i])
		local s,e = parts[i]:match('start_offset=(%d+)&end_offset=(%d+)')
		if not fsize or fsize ~= sizes[i] then
			usd.setreferer(origUrl)
			usd.get(parts[i]..'|'..files[i])
		end
	end

	usd.setreferer(origUrl)
	usd.setretresult(playlist,0,0)

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'

	--os.remove(fullName)	-- playlist

	debugLog('Joining...')
	--local tmpName = getLstInfo().saveto..script.name..'_'..id..'.ts'
	local parts, files = script.tmp.parts, script.tmp.files

	local h, err = io.open(fullName,'wb') -- playlist
	if err then
		usd.savetolog(err)
		return
	end

	for i=1, #files do
		usd.setstatus('joining part '..i..'/'..#parts)
		h:write(fileRead(files[i]))
	end
	h:close()

	debugLog('Deleting parts...')
	for i=1, #files do os.remove(files[i]) end

	return usd.setretresult(fileRename(fullName, script.tmp.newName, '.ts'))
end


regDirSuccess( '.twitch.tv/', GDL, OS)
