
function GDL(origUrl)
    logpref = script.name .. '_GDL_v14'
    usd.setstatus(script.name)
	local dirUrl, page, form

	local conf = Settings[script.name] or {}

	page = usd.head(origUrl)
	debugSaveInc(logpref..'.html', page)
	if page:lower():find('content%-disposition:') then
		usd.setretresult(usd.getlocation(), 1, 0)
		return
	end

	page = usd.get(usd.getlocation())
	debugSaveInc(logpref..'.html', page)

	local uri = URI.parse(usd.getlocation())
	if uri.path:find('^/404$') or uri.path:find('^/410/')		-- http://uploaded.net/404
	then return usd.setretresult('%notfound%') end

	if page:find('var%s+free_enabled%s*=%s*false;') then
		usd.setretresult("%No free slots")
		return
	end

	local id = uri.path:match('^/file/(%w+)')

	local inipref = script.name..'_'..getHost(uri)
	local myIP, oldIP, lastDownload
	if conf.freeDelay then
		local extIP = Settings['<misc>'].extIP or 'http://ip-api.com/csv/?fields=query'
		local page = usd.get('http://uploaded.net/api/download/Info?auth='..id)
		local data = page:match('"key":"([^|]+)')
		data = data and base64.dec(data) or '<no data>'
		debugSaveInc(logpref..'.html', page, data)
		 myIP = data:match('%d+%.%d+%.%d+%.%d+')
		oldIP = usd.getoption(plg.plgname, inipref.. '_oldIP', '<no IP>')
		if not myIP then
			usd.waittime(10)
			myIP = usd.get(extIP):match('%d+%.%d+%.%d+%.%d+') or '<no IP>'
		end
		lastDownload = usd.getoption(plg.plgname, inipref.. '_lastDownload', 0)
		local wait = (lastDownload+conf.freeDelay) - os.time()
		debugLog(('newIP=%s, oldIP=%s, wait=%s'):format(myIP, oldIP, wait))
		if myIP ~= '<no IP>' and myIP == oldIP and wait>0 then
			usd.setretresult('%Server report: You need wait ' .. wait .. ' seconds')
			return
		end
	end

	local wait = page:match('<span>Current waiting period: <span>(%d+)</span> seconds</span>')
		or page:match('<meta name="wait" content="(%d+)">')

	local slot = usd.post(uri('/io/ticket/slot/'..id)(), '%simple%')
	debugSaveInc(logpref..'.html', slot)
	if not slot:find('succ"?:true') then -- {succ:true} -- {"succ":true}
		usd.setretresult("%No free slots?")
		return
	end


	usd.waittime(wait+2,2)

	local key = '6Lcqz78SAAAAAPgsTYF3UlGf2QFQCNuPMenuyHF3%20'	-- cloudzer.net & uploaded.net

	form = Form.make{ action=uri('/io/ticket/captcha/'..id)(), method='POST' }
	form.inputs.recaptcha_response_field
		, _, form.inputs.recaptcha_challenge_field
			= queryReCaptcha(key, 0, nil, nil, nil, true) -- gooCheck
	page = form:submit()
	debugSaveInc(logpref..'.html', page)

	local data = parseJsObject(page) or {}

	if data.err then
		usd.setretresult('%'..data.err:gsub('<[^>]+>',' '))
		return
	end

	dirUrl = data and data.type == 'download' and data.url
	usd.setretresult(dirUrl, 1, 0)


	if conf.freeDelay then
		usd.setoption(plg.plgname, inipref..'_oldIP', myIP)
		usd.setoption(plg.plgname, inipref..'_lastDownload', os.time() )
	end


end

regDirSuccess('//uploaded.to/', GDL)
regDirSuccess('//uploaded.net/', GDL)
regDirSuccess('//ul.to/', GDL)
