
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v14'
	usd.setstatus(script.name)

--[[
usdLua_settings.lua:

Settings['vimeo_com'] = { interactive = false, qualityList = {'original', 'hd', 'sd', 'mobile'}, codecList = {'original', 'h264', 'vp8', 'vp6'} }
interactive -   


]]


--http://player.vimeo.com/video/58335679?autoplay=0&title=0&byline=0&wmode=opaque

	local conf = Settings[script.name] or { interactive = false, qualityList = {'original', '1080p', '720p', '360p', '270p'}}
	debugLog(serialize(conf))

	local dirUrl, page

	--local exts = { vp8 = '.webm', vp6 = '.flv', h264 = '.mp4' }

	script.tmp={}

	local resume = 0

	--   
	local fmt = string.match(origUrl, '#fmt=(%w+)')
	if fmt then
		fmt = tonumber(fmt) or fmt
		resume = 1
		origUrl = origUrl:match('^([^#]+)')
	end

	local id = origUrl:match('/(%d+)')

	local tmp = 'http://vimeo.com/'..id
	usd.setreferer(tmp)
	page = usd.get(tmp)
	debugSaveInc(logpref..'.html', page)

	--if page:find('<h1>%s*Permission Denied') then
	if parseHeaders().CODE~=200 then
		tmp = 'http://player.vimeo.com/video/'..id
		usd.setreferer(tmp)
		page = usd.get(tmp)
		debugSaveInc(logpref..'.html', page)
	end

	if parseHeaders().CODE~=200
		or page:find('>This video does not exist.<')
		or page:find('>Vimeo has removed or disabled access')
		or page:find('<h1>%s*Page not found%s*</h1>')
		then
			if page=='' then return usd.setretresult('%empty page') end
			usd.setretresult('%notfound%')
			return
	end

	local data = page:match('data%-config%-url="([^"]+)"')
		or page:match('%.open%("GET","(https?://player%.vimeo%.com/video/%d+/config[^"]+)"')
		or page:find('"config_url":"https?:') and unescapeJS(page:match('"config_url":"(https?:[^"]+)"'))
		or page:match('https?://player%.vimeo%.com/video/'..id..'/config[^\'"%s]+')
		or 'http://player.vimeo.com/video/'..id..'/config'
	page = usd.get(entityDecode(data):gsub('^https:','http:'))
	data = parseJsObject(page)
	debugSaveInc(logpref..'.html', page, serialize(data or {},nil,true), 'data-config-url')

    local qData = {}
    local qData2 = {}

	usd.setreferer('http://vimeo.com/'..id)
	setXHR()
	local tmpOrig = usd.get('http://vimeo.com/'..id..'?action=download')
	setXHR(true)
	debugSaveInc(logpref..'.html', tmpOrig)


	for k, v in ipairs(data.request.files.progressive) do
		v.url=v.url:gsub('^https:','http:')
		qData[v.quality] = v
	end

	for url,res,w,h,size in tmpOrig:gmatch('<li class="iconify_down_b">%s*<a href="([^"]+)"[^>]+>([^<]+)</a>%s*<span>%((%d+)x(%d+)[^<]+</span>%s*</li>') do
		w, h = tonumber(w), tonumber(h)
		res=res:lower():gsub('^.-%s(%d+p)$','%1')
		res = ({sd='480p', ["mobile sd"]='270p'})[res] or res
		local skip=qData[res]
		if not skip then for k, v in pairs(qData) do if v.width==w and v.height==h then skip=true; break end end end
		if not skip then
			debugSaveInc(logpref..'.html', usd.head(url:gsub('^https:','http:')), res)
			qData[res]={url = usd.getlocation():gsub('^https:','http:'), fileSize = size, width = w, height = h}
		end
	end


	debugSaveInc(logpref..'.html', serialize({qData=qData},nil,true), nil, false)

	local title = utf8ToAnsi(trim(data.video.title or ''))
	if title=='' then title = id end
	script.tmp.newName = title

	if fmt and qData[fmt] then
		dirUrl = qData[fmt].url
		--dirUrl = addNewName(dirUrl, title)	--   
		if conf.addName and not dirUrl:find('filename=') then dirUrl = dirUrl..(dirUrl:find('?') and '&' or '?')..'download=1&filename='..title..'.mp4' end
		usd.setretresult( dirUrl, 0, resume )
		return
	end

	resume = 0

	if conf.interactive then

		local info = {}

		for k, q in ipairs(conf.qualityList) do
		    local size
			if qData[q] then
				debugSaveInc(logpref..'.html', usd.head(qData[q].url), tostring(q))
				qData[q].url = usd.getlocation():gsub('^https:','http:')
				size = usd.getheaders():match('HTTP/%d%.%d 200 OK') and usd.getheaders():match('Content%-Length: (%d+)')
				size = size and (not tonumber(size) and size:gsub('%a+$','') or string.format('%0.2f', size / 1024 / 1024)) or ' ??????'
				local res = (qData[q].width or 0)..'x'..(qData[q].height or 0)
				table.insert(info, ('%s: %s MB  %s'):format(
					  pad(q, 5, '  ')
					, pad(size, 7, '  ')
	                , pad(res, 9, '  ')
				))
			end
		end

		data.video = tableCombine({duration=0,width=0,height=0}, data.video)
		local duration = math.floor(data.video.duration / 60).. ':' .. pad(data.video.duration % 60, 2)
		local res = data.video.width .. 'x' .. data.video.height

		local dlg = {
			{duration, res, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		local dlg = Dialog.new(dlg, script.name)
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		q = info[tonumber(q)]:match('^%s*(%w+):')
		fmt = tonumber(q) or q
		usd.modquery(origUrl .. '#fmt='..fmt)
		dirUrl = qData[fmt].url --- .. '&title=' .. escapeUC(title)
		--dirUrl = addNewName(dirUrl, title)	--   
		if conf.addName and not dirUrl:find('filename=') then dirUrl = dirUrl..(dirUrl:find('?') and '&' or '?')..'download=1&filename='..title..'.mp4' end
		usd.setretresult( dirUrl, 0, resume )
		return
	end

	for k, q in ipairs(conf.qualityList) do
		if qData[q] then
			fmt = q
			break
		end
    end

	if not fmt then	--   
		fmt = next(qData)
	end

	dirUrl = qData[fmt].url
	usd.modquery(origUrl .. '#fmt='..fmt)
	--dirUrl = addNewName(dirUrl, title)	--   
	if conf.addName and not dirUrl:find('filename=') then dirUrl = dirUrl..(dirUrl:find('?') and '&' or '?')..'download=1&filename='..title..'.mp4' end
	usd.setretresult( dirUrl, 0, resume )

end

function OS(origUrl, dirUrl, fullName)
	logpref = script.name .. '_OS'
	return usd.setretresult(fileRename(fullName, script.tmp.newName, script.tmp.newExt or '.mp4'))
end


regDirSuccess( '//vimeo.com/', GDL, OS)
regDirSuccess( '.vimeo.com/', GDL, OS)
