
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v08'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri, data

	local conf = Settings[script.name] or {
		  interactive = false
		, qualityList = {720, 480, 360, 240}
	}
	debugLog('conf='..serialize(conf,nil,nil,true))

	local function checkError(page)
	    local err, errcode
	    if type(page)=='table' then
	    	err = page.error and page.error.error_msg
	    	if not err then return false end
	    	errcode = page.error.error_code
		end

		err = err
			or page:match('<div class="title"></div>%s*<div[^>]+>%s*([^<]-)%s*<')
			or page:match("<div id='message'[^>]+>(   ,    ).<")
			or page:match('^<!%-%-%d+<!><!>%d+<!>%d+<!>%d+<!>([^<]+)')
			or page:match('<div class="(profile_deleted)">')
		if err then
			if err=='deleted'
				or err==' '
				or err=='   ,    '
				or err==',   ,    .'
				or err=='profile_deleted'
				or errcode == 200
				or err:find('^,  ')
				then
				usd.savetolog(err)
				usd.setretresult('%notfound%')
			else
				usd.setretresult('%'..err)
			end
		end
		return err
	end

	uri = URI.parse(origUrl)
	local fmt = (uri.fragment or ''):match('fmt=([_%w]+)')
	fmt = fmt and tonumber(fmt) or fmt
	origUrl = uri()

	if origUrl:find('%.vk%.me/') then
		local info = getLstInfo(true)
		if info.localfile then
			local pusdsize = fileSize(info.localfile..'.pusd')
			if pusdsize then
				usd.setcookie('remixlang=0')
				setHeader('Range: bytes='..pusdsize..'-')
			end
		end
		return usd.setretresult((origUrl:gsub('(%?.-)%?/','%1&/')),1,1)
	end


	local p = '(%a+)((%-?%d+)_?(%-?%d*)[^&]*)'
	local res, id0, id1, id2 = (uri.query or ''):match('[zw]='..p)
	if not res then res, id0, id1, id2 = (uri.fragment or ''):match('^/'..p) end
	if not res then res, id0, id1, id2 = uri.path:match('^/'..p) end
	local list = id0 and id0:match('%%2F(%w+)')
	if id2=='' then id2=nil end
	--if res=='id' then res='photos' end

	if uri.p[1]=='video_ext.php' then
		res = 'video'
		id1 = uri.q.oid
		id2 = uri.q.id
		id0 = id1..'_'..id2
	end
	debugLog(serialize({res=res, id0=id0, id1=id1, id2=id2, list=list}))

	if res=='album' then
		local oid, aid = id1, id2
		aid = ({['0']='profile', ['00']='wall', ['000']='saved'})[aid] or aid
		page = usd.get('http://api.vk.com/method/photos.get?oid='..oid..'&aid='..aid)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'_album.html', page, res..'\r\n\r\n'..serialize(data or {},nil,true))
		if checkError(data) then return end
		for _, v in ipairs(data.response) do
			usd.addquery('http://vk.com/photo'..v.owner_id..'_'..v.pid)
		end
		usd.setretresult('%done%')
		return
	end


	if res=='albums' then
		page = usd.get('http://api.vk.com/method/photos.getAlbums?need_system=1&owner_id='..id1)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'_albums.html', page, serialize(data or {},nil,true))
		if checkError(data) then return end
		if #data.response<2 then
			page = usd.get('http://api.vk.com/method/photos.getAlbums?need_system=1&owner_id='..id1)
			data = parseJsObject(page)
			debugSaveInc(logpref..'_albums.html', page, serialize(data or {},nil,true))
			if checkError(data) then return end
		end
		local sys={[-6]='0', [-7]='00', [-15]='000'}
		for k, v in ipairs(data.response) do
			local title = v.title and tostring(v.title)
			title = (title and #title>0 and '#'..filterName(utf8ToAnsi(title)):gsub('[%s_"\']+','_'):gsub('_?%-_?','-') or ''):sub(1,128)
			usd.addquery('http://vk.com/album'..v.owner_id..'_'..(sys[v.aid] or v.aid)..title)
		end
		usd.setretresult('%done%')
		return
	end

	if res=='photos' or res=='tag' then
	    local offset = 0
		repeat
			page = usd.post(origUrl, '%simple%al=1&part=1&offset='..offset)
			debugSaveInc(logpref..'.html', page, res)
			if checkError(page) then return end
			for a in page:gmatch('<div class="photo_row"[^>]+>.-<a href="([^"]+)"') do
				usd.addquery(uri(a)())
				offset = offset+1
			end
		until not page:find('<div class="photo_row"')

		usd.setretresult('%done%')
		return
	end

	if res=='photo' then
		--page = usd.get('http://vk.com/photo'..id0)
		page = usd.get('http://vk.com/photo'..id1..'_'..id2)
		debugSaveInc(logpref..'.html', page, res)
		if checkError(page) then
			local dir2 = uri.fragment and uri.fragment:match('__dir2=(.+)')
			if dir2 then usd.setretresult('http://'..dir2,0,1) end
			return
		end
		usd.modquery(origUrl)
		--local obj = page:match('{"id":"'..id0:gsub('%-','%%-')..'".-},{"id"')
		--	or page:match('{"id":"'..id0:gsub('%-','%%-')..'".-}%]')
		local tmp = id1:gsub('%-','%%-')..'_'..id2
		local obj = page:match('{"id":"'..tmp..'".-},{"id"')
			or page:match('{"id":"'..tmp..'".-}%]')
		obj = parseJsObject(obj)
		debugSaveInc(logpref..'.html', serialize(obj or {},nil,true), nil, false)
        local author = obj.author:match('>(.-)</a>') or obj.author or ''
        local album = obj.album:match('>(.-)</a>') or obj.album or ''
        local newName = ('%s-%s-%s%s'):format(author, album, obj.id, obj.place and '-'..obj.place or '' )
		dirUrl = obj.w_src or obj.z_src or obj.y_src or obj.x_src or obj.r_src or obj.q_src or obj.p_src or obj.o_src
		dirUrl = addNewName(dirUrl, newName)
		usd.setretresult(dirUrl, 0, 1)
		return
	end



	if res=='doc' then
		page = usd.get(origUrl)
		debugSaveInc(logpref..'.html', page, res)
		dirUrl = page:match("var%s+src%s*=%s+'([^']+)'")
		usd.setretresult(dirUrl,1,1)
		return
	end


	if res=='topic' then
		page = usd.get('http://api.vk.com/method/board.getComments?group_id='..(id1:gsub('^%-',''))..'&topic_id='..id2)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'_topic.html', page, serialize(data or {},nil,true))
		local err = data.error and data.error.error_msg
		if err then return usd.setretresult('%'..err) end
		for i=2, data.response.comments[1] do
			debugLog('i='..i)
			for k, v in ipairs(data.response.comments[i].attachments) do
				if v.type=='photo' then
					local dir2 = v.photo.src_xxxbig or v.photo.src_xxbig or v.photo.src_xbig or v.photo.src_big or v.photo.src or v.photo.srs_small
					dir2 = addNewName(dir2, res..id0..'-'..pad(i-1,3)..'-'..pad(k,2))
					usd.addquery(dir2)
				else
					debugLog('topic attach skipped: '..v.type)
				end
			end
		end
		usd.setretresult('%done%')
		return
	end

	local function getAttachments(data,start,field)
		for i=start, #data.response do
			local attachments = data.response[i].attachments
			if attachments then for ii=1, #attachments do
				if usd.progstatus() == 0 then return end	-- stopped
				local atype = attachments[ii].type
				local attach = attachments[ii][atype]
				local atitle = (attach.title and '#'..filterName(utf8ToAnsi(attach.title)):gsub('[%s_"\']+','_'):gsub('_?%-_?','-') or ''):sub(1,128)
				local aurl = attach.owner_id and 'http://vk.com/'..atype..attach.owner_id..'_'
				if atype=='photo' then
					local dir2 = attach.src_xxxbig or  attach.src_xxbig or attach.src_xbig or attach.src_big or attach.src or attach.srs_small
					dir2 = dir2 and '#__dir2='..dir2:gsub('^https?://','') or ''
					usd.addquery(aurl..attach.pid..dir2)
				elseif atype=='video' then
					usd.addquery(aurl..attach.vid..atitle)
				elseif atype=='doc' then
					usd.addquery(aurl..attach.did..atitle)
				elseif atype=='album' then
					usd.addquery(aurl..attach.aid..atitle)
				elseif atype=='link' then
					usd.addquery(attach.url)
				elseif atype=='audio' then
					local dir2 = attach.url:match('^https?://([^?]+)')
					dir2 = dir2 and '__dir2='..dir2:gsub('^https?://','') or ''
					local title = '#'..filterName(utf8ToAnsi((attach.artist or 'noartist')..'-'..(attach.title or 'notitle'))):gsub('[%s_"\']+','_'):gsub('_?%-_?','-')
					usd.addquery(aurl..attach.aid..title..dir2)
				elseif atype=='poll' or atype=='page' then
				else
					debugLog('Unknown type: '..atype)
				end
			end end
		end
	end

	if res=='wall' then
		if id2 then
			page = usd.get('http://api.vk.com/method/wall.getById?posts='..id0)
			local data = parseJsObject(page)
			debugSaveInc(logpref..'_wallpost.html', page, serialize(data or {},nil,true))
			local err = data.error and data.error.error_msg
			if err then return usd.setretresult('%'..err) end
			getAttachments(data,1)
		else
		    local offset = (uri.fragment or ''):match('offset=(%d+)')
		    offset = tonumber(offset or 0)
			repeat
				page = usd.get('http://api.vk.com/method/wall.get?count=50&owner_id='..id1..'&offset='..offset)
				local data = parseJsObject(page)
				debugSaveInc(logpref..'_wall.html', page, serialize(data or {},nil,true))
				local err = data.error and data.error.error_msg
				if err then return usd.setretresult('%'..err) end
				getAttachments(data,2)
				offset = offset + #data.response - 1
				usd.modquery(origUrl..'#offset='..offset)
				usd.setstatus(offset..' / '..data.response[1])
			until offset>=data.response[1]
		end
		usd.setretresult('%done%')
		return
	end

	if res=='audio' or res=='audios' then
		local dir2 = (uri.fragment or ''):match('__dir2=(.+)')
		if dir2 then
			usd.setretresult('http://'..dir2,0,1)
		else
			usd.setretresult('%notfound%')
		end
		return
	end

	if res=='videos' then
		page = usd.post('http://vk.com/al_video.php', '%simple%act=load_videos_silent&al=1&oid='..id1)
		local data = parseJsObject(page)
		debugSaveInc(logpref..'.html', page, res..'\r\n\r\n'..serialize(data or {},nil, true))
		for k, v in ipairs(data.all) do
			local name = filterName(entityDecode(v[4])):gsub('[%s_"\']+','_'):gsub('_?%-_?','-')
			debugLog(name)
			usd.addquery('http://vk.com/video'..v[1]..'_'..v[2]..'#'..name)
		end
		usd.setretresult('%done%')
		return
	end

	if res=='video' then
		--local list = uri.query and uri.query:match('z=video%-?%d+_%d+%%2F(videos%d+)')
		page = usd.post('http://vk.com/al_video.php', '%simple%act=show&al=1&autoplay=0&module=profile&video='..id0..(list and '&list='..list or ''))
		data = parseJsObject(page:match('var vars = {.-};') or '') or {'<nil>'}
		debugSaveInc(logpref..'.html', page, res..'\r\n\r\n'..serialize(data, nil,true))
		local iframe = (page:match('<div id="video_player" style="width:896px; height:504px;">.-</div>') or ''):match('<iframe[^>]-src="([^"]+)"')
		if iframe then return getMirror({iframe}) end
		local err = page:match('<!><div id="video_player" class="video_layer_message">(.-)</div><!>')
		if err then
			err = err:gsub('<[^>]+>',' ')
			usd.savetolog(err)
			if err:find('    ') then
				err = 'deleted%'
			end
			usd.setretresult('%'..err)
			return
		end
	else
		--page = usd.get(origUrl)
		--page = get(origUrl)
		page = urlGet(origUrl,{tries=5,referer=''})
		data = parseJsObject(page:match('var vars = {.-};') or '')
		debugSaveInc(logpref..'.html', page, serialize(data or '<nil>',nil,true))
	end

	if checkError(page) then return end

	local external = page:match('<iframe id=\\?"video_player\\?"[^>]-src=\\?"(http:.-)\\?"')
	if external then
		external = external:gsub('\\','')
		debugLog('External video: '..external)
		usd.modquery(external)
		--usd.setretresult('%Restarting...',5)
		usd.setretresult('http://0.0.0.0/?Restarting...',0)
		return
	end

	script.tmp={}

	local resume = 0

	local title = data.md_title and entityDecode(data.md_title)
		 or	entityDecode( page:match('"md_title":"([^"]+)"')
		 or page:match('<meta property="og:title" content="([^"]+)"') or 'notitle' , true)
	--if origUrl:find('/video_ext.php') then title = utf8ToAnsi(unescape(title)):gsub('%+',' ') end
	local duration = --data and data.mvData and data.mvData.duration or
		page:match('"duration":(%d+)') or page:match('<meta property="og:video:duration" content="(%d+)"')
	duration = math.floor(duration / 60).. ':' .. pad(duration % 60, 2)

	local qlist = {}
	local urls = {}
	local info = {}

--,\"url240\":\"http:\\\/\\\/cs506423v4.vk.me\\\/u54990779\\\/videos\\\/4c4503f7e9.240.mp4\"
	for q, v in page:gmatch('"url(%d+)\\?":\\?"(https?:.-)\\?"') do
		q = tonumber(q)
		if not urls[q] then
			table.insert(qlist, q)
			urls[q] = v:gsub('^https:','http:'):gsub('\\','')
		end
	end

	debugSaveInc(logpref..'.html', serialize(urls,nil, true), nil, false)

	local function selectVideo(fmt, head)
		if head then
			debugSaveInc(logpref..'.html', usd.head(urls[fmt]), origUrl)
			local h = parseHeaders()
			if not (h.CODE==200 and h.SIZE) then return false end
		else
			usd.modquery(origUrl .. '#fmt='..fmt)
		end
		usd.setreferer(origUrl)
		local fext = urls[fmt]:match('%.[^.]+$')
		dirUrl = addNewName(urls[fmt], title, nil, nil, fext)
		usd.setretresult( dirUrl, 0, resume )
		return true
	end

	if fmt and urls[fmt] then
		resume = 1
		return selectVideo(fmt, true)
	end

	if conf.interactive then
		table.sort(qlist, function(a,b) return a>b end)	-- reverse
		for k, v in ipairs(qlist) do
			debugSaveInc(logpref..'.html', usd.head(urls[v]), origUrl)
			local h = parseHeaders()
			local size = h.CODE==200 and h.SIZE
			if size then
				size = string.format('%0.2f', size / 1024 / 1024) or ' ??????'
				table.insert( info, string.format('%s: %s MB', pad(v, 4, '  '), pad(size, 7, '  ') ) )
			else
				urls[v]=nil
			end
		end

		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		if usd.progstatus() == 0 then debugLog('USD stopped') return end
		local q = dlg:show()
		if q == '' then return end		-- esc
		q = q:match('quality=([%d]+)') + 1	--     0
		fmt = tonumber(info[q]:match('^%s*(%d+)'))
		return selectVideo(fmt)
	end

	for k, v in ipairs(conf.qualityList) do
		if urls[v] then
			fmt = v
			if selectVideo(fmt, true) then break end
		end
	end


end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '//vk.com/', GDL, OS)
regDirSuccess( '.vk.com/', GDL, OS)
regDirSuccess( '//vkontakte.ru/', GDL, OS)
regDirSuccess( '.vk.me/', GDL, OS)
