
function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v01'
	usd.setstatus(script.name)
	local dirUrl, page, badpage, form, uri

	local conf = Settings[script.name] or {
		  interactive = false
		, qualityList = {'480p_1200k','480p_370k','240p_240k','180p_150k'}
	}

	uri = URI.parse(origUrl)
	origUrl = uri()

	page = usd.get(origUrl)
	debugSaveInc(logpref..'.html', page)

	script.tmp={}
	--usd.waittime(2, 2)

	local fmt = (uri.fragment or ''):match('fmt=(%w+_%w+)')

	local duration = page:match('"duration_f":"(.-)"')
	local title = page:match('<h1 class="grid_9">([^<]+)</h1>')
	local urls = {}
	local info = {}

	for tmp in page:match('<ul class="downloadList">.-</ul>'):gmatch('<li[^>]->(.-)</li>') do
		local url = entityDecode(tmp:match('href="([^"]+)"'))
		local id = url:match('^[^/]+//[^/]+/[^/]+/[^/]+/[^/]+/(%w+_%w+)_')
		local descr = trim(entityDecode((tmp:gsub('<[^>]+>',' ')),true):gsub('[\160%s]+',' '))
		urls[id] = url
		table.insert(info, ('%s: %s'):format(pad(id,12,'  '),descr))
	end

	if fmt and urls[fmt] then usd.setretresult(urls[fmt],1,1) return end

	if conf.interactive then
		local dlg = {
			{duration, title}
			, {'__________________________'}
			, {'Select quality:'}
			, {{type='select', name='quality', info }}
		}
		dlg = Dialog.new(dlg, script.name)
		if usd.progstatus() == 0 then
			debugLog('USD stopped')
			return
		end
		local q = dlg:show()
		if q == '' then debugLog('Esc') return end		-- esc
		q = tonumber(q:match('quality=([%d]+)')) + 1	--     0
		fmt = info[q]:match('^%s*([^:]+)')
		uri.fragment='fmt='..fmt
		usd.modquery(uri(nil,true))
		usd.setretresult(urls[fmt], 0, 0 )
		return
	end

	for i,v in ipairs(conf.qualityList) do
		if urls[v] then
			dirUrl = urls[v]
			fmt = v
			debugLog('fmt: '..v)
			break
		end
	end

	if dirUrl == nil then
		fmt, dirUrl = next(urls)
		debugLog('selected: '..fmt)
	end

	uri.fragment='fmt='..fmt
	usd.modquery(uri(nil,true))

	usd.setretresult(dirUrl, 0, 0)
end

--function OS(origUrl, dirUrl, fullName)
--	logpref = script.name .. '_OS'
--	return usd.setretresult(fileRename(fullName, script.tmp.newName))
--end


regDirSuccess( '.youporn.com/watch/', GDL, OS)
