--GDL

local noRedirects = {}

function GDL(origUrl) 	-- GetDirectLink
	logpref = script.name .. '_GDL_v02'
	local dirUrl, page, badpage, form, uri
	script.tmp={}


	uri = URI.parse(origUrl)
	local host = getHost(uri)

	usd.setstatus(script.name .. ': ' .. host )

	local cacheKey = origUrl
	local tmp = Cache.get(cacheKey)
	if tmp then
		script.tmp.newName = tmp.newName
		return
	end

	local function getForm(page)
		local forms = {Form.parse(page, origUrl)}
		local form
		for k, v in pairs(forms) do
			if v.inputs.submitted and v.inputs.d then
				form=v
				break
			end
		end
		if not form then return end
		if form.html:find('g%-recaptcha') and form.html:find('data%-sitekey') then
			queryReCaptcha2({form=form, check=true})
		elseif form.html:find('/recaptcha/api/challenge%?k=') then
			queryReCaptcha({form=form, check=true})
		end
		return form
	end

	local function getDirUrl(page)
		local l1 = parseHeaders().LOCATION1 or ''
		dirUrl = page:match('https?://[^/]+/%S-%?download_token=%x+')
			or l1:match('https?://[^/]+/%S-%?download_token=%x+')
			or l1:match('https?://[^/]+/files/%x+/%x+/%S-[?&]expires=.*')
		if dirUrl then
			usd.setretresult(dirUrl:gsub('^https:','http:'),1,1)
			Cache.set(cacheKey, {dirUrl=dirUrl, cookie=usd.getcookie(), referer=usd.getlocation(), newName=script.tmp.newName})
			return true
		end
	end

	local function checkError(page)
		local err = page:match("<ul class='pageErrors'>(.-)</ul>")
			or usd.getlocation():find('/error%.html%?e=') and usd.getlocation():match('/error%.html%?e=(.+)')
			or page:match('<center>%s*<h2>([^<]+)</h2>')
		if not err then return end
		err = trim((err:gsub('<[^>]+>',' ')))
		if err:find('File has been removed')
			or err:find('Could+not+open+file+for+reading',1,true)
			or err:find('File+has+been+removed',1,true)
			then err = 'deleted%' end
		usd.setretresult('%'..err)
		return true
	end

	--debugSaveInc(logpref..'.html', usd.get(uri('/index.html?_t=English+%28en%29')()))
	--usd.waittime(2,2)

	local nextPage = origUrl

	for i=1, 10 do
		if i~=1 then usd.relocationmode(0) end
		page = shitFlare(nextPage)
		debugSaveInc(logpref..'.html', page, 'p-'..i)
		if i==1 then uri = URI.parse(origUrl) end
		local wait = tonumber(page:match('var seconds = (%d+)') or 0)
		if checkError(page) then return end
		usd.waittime(wait+2, 2)
		if getDirUrl(page) then return end
		local form = getForm(page)
		if form then
			if noRedirects[host] then
				usd.setretresult(form.action,1,1,form:getinputs())
				return
			end
			usd.relocationmode(0)
			page = form:submit()
			debugSaveInc(logpref..'.html', page, 'captcha?')
			if checkError(page) or getDirUrl(page) then return end
		end
	    nextPage = page:match('<a[^>]-href=[\'"]([^\'"]-%?pt=[^\'"]+)')
	end

	usd.setretresult('%plugindefect')
end

function OS(origUrl, dirUrl, fullName, headers)
	logpref = script.name .. '_OS'
	local newName = filterName(utf8ToAnsi(parseHeaders(headers).FILENAME), true)
	Cache.del(origUrl)
	return usd.setretresult(fileRename(fullName, newName))
end

function OE(dirUrl, errMsg, data)
	if dirUrl:find('/error.html?e=Error%3A+Could+not+open+file+for+reading.',1,true) then
		usd.setretresult(0)
	end
end
regCheckError('/error.html?e=Error%3A+', nil, OE)

local function reg(DS, hostNR)
	if type(DS)=='string' then DS = {DS} end
	for k, v in ipairs(DS) do
		regDirSuccess('//'..v..'/', GDL, OS)
		regDirSuccess('.'..v..'/', GDL, OS)
		if hostNR then noRedirects[v]=v end
	end
end

-- no captcha
regDirSuccess( '//uploadbb.co/', GDL, OS)

-- recaptcha
regDirSuccess( '//upple.it/', GDL, OS)
regDirSuccess('//4upld.com/', GDL, OS)
reg('host4files.com', true)
regDirSuccess( {'//amonshare.com/','.amonshare.com/'}, GDL, OS)

-- recaptcha2
regDirSuccess('//letitload.com/', GDL, OS)
regDirSuccess('.sbupload.com/', GDL, OS)
